/*
 * Auto Alarm, www.bladox.com
 *
 * Copyright (C) 2004-2006 BLADOX, s.r.o.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */

 /* 
  * Added sub-version (VERSION_C) for Lang adaptations Follow-up  (Hpe)
  */

#include <config.h>
#include <turbo/turbo.h>

#include <avr/sfr_defs.h>
#include <avr/io.h>

#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "delay.h"
#include "pins.h"
#include "i2cma.h"
#include "uart2i2c.h"

#define MY_SLAVE_ADDRESS 0x7E

/*
- RU start/end_ucs2 cosmetics
*/

/* *INDENT-OFF* */

lc_char PROGMEM lc_Auto_Alarm[] = {
  LC_EN ("Auto Alarm")
//  LC_FR ("Alarme")
//  LC_EL("\30YNA\23EPMO\30")
  LC_HU("Auto Riaszto")
// WARNING - too long
  LC_RU("\204\10\31\200\4\20\4\62\4\102\4\76\0\40\4\101\4\70\4\63\4\75\4\60\4\73\4\117")
  LC_END
};

lc_char PROGMEM lc_Alarm[] = {
  LC_EN ("Alarm")
  LC_FR ("Alarme") 
  LC_EL("\30YNA\23EPMO\30")
  LC_HU("Riasztas")
LC_RU("\204\10\17\200\4\42\4\100\4\65\4\62\4\76\4\63\4\60")
  LC_END
};

lc_char PROGMEM lc_GPS[] = {
  LC_EN ("GPS")

  LC_END
};

lc_char PROGMEM lc_Alarm_Config[] = {
  LC_EN ("Setup")
  LC_FR ("Configuration")
  LC_NO ("Oppsett") 
  LC_DE ("Einstellungen") 
  LC_CZ ("Nastaveni") 
  LC_EL("PY\31MI\30EI\30")
  LC_HU("Beallitas")
LC_RU("\204\10\23\200\4\35\4\60\4\101\4\102\4\100\4\76\4\71\4\72\4\60")
  LC_END
};

lc_char PROGMEM lc_Alarm_Lock[] = {
  LC_EN ("Activate")
  LC_FR ("Activer") 
  LC_NO ("Aktivere")
  LC_DE ("Einschalten") 
  LC_CZ ("Zapnout") 
  LC_EL("ENEP\23O\26OIH\30E")
  LC_HU("Bekapcsol")
LC_RU("\204\10\31\200\4\20\4\72\4\102\4\70\4\62\4\70\4\100\4\76\4\62\4\60\4\102\4\114")
  LC_END
};

lc_char PROGMEM lc_Alarm_Unlock[] = {
  LC_EN ("Deactivate")
  LC_FR ("D\5sactiver") 
  LC_NO ("Avbryte")
  LC_DE ("Ausschalten") 
  LC_CZ ("Vypnout") 
  LC_EL("A\26ENEP\23O\26OIH\30E")
  LC_HU("Kikapcsol")
LC_RU("\204\10\35\200\4\24\4\65\4\60\4\72\4\102\4\70\4\62\4\70\4\100\4\76\4\62\4\60\4\102\4\114")
  LC_END
};

lc_char PROGMEM lc_Alarm_Locked[] = {
  LC_EN ("Activated") 
  LC_FR ("Activ\5")
  LC_NO ("Aktivert")
  LC_DE ("An") 
  LC_CZ ("Zapnuto") 
LC_EL("ENEP\23O\26OIHMENO")
LC_HU("Bekapcsolva")
LC_RU("\204\10\31\200\4\20\4\72\4\102\4\70\4\62\4\70\4\100\4\76\4\62\4\60\4\75\4\60")
  LC_END
};

lc_char PROGMEM lc_Alarm_Unlocked[] = {
  LC_EN ("Deactivated") 
  LC_FR ("D\5sactiv\5")
  LC_NO ("Deaktivert")
  LC_DE ("Aus") 
  LC_CZ ("Vypnuto") 
LC_EL("A\26ENEP\23O\26OIHMENO")
LC_HU("Kikapcsolva")
LC_RU("\204\10\35\200\4\24\4\65\4\60\4\72\4\102\4\70\4\62\4\70\4\100\4\76\4\62\4\60\4\75\4\60")
  LC_END
};

lc_char PROGMEM lc_New_Number[] = {
  LC_EN ("New Number") 
  LC_FR ("Nouveau Num\5ro")
  LC_NO ("Nytt Nummer")
  LC_DE ("Neue Nummer") 
  LC_CZ ("Nove cislo") 
  LC_EL("NEO TH\24E\22\25NO")
  LC_HU("Uj szam")
LC_RU("\204\10\27\200\4\35\4\76\4\62\4\113\4\71\0\40\4\35\4\76\4\74\4\65\4\100")

  LC_END
};

lc_char PROGMEM lc_Numbers[] = {
  LC_EN ("Numbers") 
  LC_FR ("Num\5ros")
  LC_NO ("Nummer")
  LC_DE ("Nummern") 
  LC_CZ ("Cisla") 
  LC_EL("TH\24E\22\25NA")
  LC_HU("Szamak")
LC_RU("\204\10\15\200\4\35\4\76\4\74\4\65\4\100\4\60")
  LC_END
};

lc_char PROGMEM lc_Status_Alarm[] = {
  LC_EN ("Alarm: ") 
  LC_FR ("Alarme: ")
//LC_EL("\30YNA\23EPMO\30: ")
LC_HU("Riasztas: ")
LC_RU("\204\10\23\200\4\42\4\100\4\65\4\62\4\76\4\63\4\60\0\72\0\40")
  LC_END
};

lc_char PROGMEM lc_Status_Locked[] = {
  LC_EN ("Activated: ") 
  LC_FR ("Activ\5: ")
  LC_NO ("Aktivert: ")
  LC_DE ("An: ") 
  LC_CZ ("Zapnuto: ") 
//LC_EL("ENEP\23O\26OIHMENO: ")
LC_HU("Bekapcsolt: ")
LC_RU("\204\10\35\200\4\20\4\72\4\102\4\70\4\62\4\70\4\100\4\76\4\62\4\60\4\75\4\60\0\72\0\40")
  LC_END
};

#ifdef CONFIG_BLOCK
lc_char PROGMEM lc_Status_Blocked[] = {
  LC_EN ("Blocked: ") 
  LC_FR ("Bloqu\5: ")
  LC_NO ("Blokkert: ")
  LC_DE ("Gesperrt: ") 
  LC_CZ ("Blokovano: ") 
//  LC_EL("M\26\24OKAPI\30MENO: ")
  LC_HU("Lealitva: ")
LC_RU("\204\10\37\200\4\27\4\60\4\61\4\73\4\76\4\72\4\70\4\100\4\76\4\62\4\60\4\75\4\60\0\72\0\40")
  LC_END
};
#endif

#ifdef CONFIG_AIRCON
lc_char PROGMEM lc_Status_AC[] = {
  LC_EN ("Aircon: ") 
  LC_FR ("Climatisation: ")
  LC_DE ("Klimaanlage: ") 
  LC_CZ ("Klima: ") 
//  LC_EL("K\24IMATI\30MO\30: ")
  LC_HU("Klimatizacio: ")
LC_RU("\204\10\33\200\4\32\4\76\4\75\4\64\4\70\4\106\4\70\4\76\4\75\4\65\4\100\0\72\0\40")
  LC_END
};
#endif

        //LC_NO("Alarm På")
lc_char PROGMEM lc_SMS_Locked[]={
        LC_EN("Alarm Activated")
        LC_FR("Alarme Activ\5e")
        LC_NO("Alarm Pa")
        LC_DE("Alarm an") 
        LC_CZ("Alarm zapnut")
        LC_EL("\30YNA\23EPMO\30 ENEP\23O\26OIHMENO\30")
        LC_HU("Riaszt Bekapcs")
LC_RU("\204\10\63\200\4\41\4\70\4\63\4\75\4\60\4\73\4\70\4\67\4\60\4\106\4\70\4\117\0\40\4\60\4\72\4\102\4\70\4\62\4\70\4\100\4\76\4\62\4\60\4\75\4\60")
        LC_END
};

lc_char PROGMEM lc_SMS_Unlocked[]={
        LC_EN("Alarm Deactivated")
        LC_FR("Alarme d\5sactiv\5e")
        LC_NO("Alarm Av")
  	LC_DE("Alarm aus") 
        LC_CZ("Alarm vypnut")
	LC_EL("\30YNA\23EPMO\30 A\26ENEP\23O\26OIHMENO\30")
        LC_HU("Riaszt Kikapcs")
LC_RU("\204\10\67\200\4\41\4\70\4\63\4\75\4\60\4\73\4\70\4\67\4\60\4\106\4\70\4\117\0\40\4\64\4\65\4\60\4\72\4\102\4\70\4\62\4\70\4\100\4\76\4\62\4\60\4\75\4\60")
        LC_END
};

lc_char PROGMEM lc_Number_Send_Alarm[]={
        LC_EN("Notify Alarm")
        LC_FR("Notifier Alarme")
        LC_NO("Sender Alarm")
  	LC_DE("Alarm melden")
        LC_CZ("Hlasit alarm")
	LC_EL("EI\20O\26OIH\30H \30YNA\23EPMOY")
        LC_HU("Riaszt Jelzes")
LC_RU("\204\10\27\200\4\43\4\62\4\65\4\64\4\76\4\74\4\73\4\65\4\75\4\70\4\65")
        LC_END
};

lc_char PROGMEM lc_FAX_SMS[]={
        LC_EN("FAX SMS Alarm")
//TODO        LC_FR("Utiliser Turbo SMS")
//TODO        LC_NO("Benytt Turbo SMS")
        LC_CZ("FAX SMS Alarm")
//TODO	LC_DE("TSMS benutzen")
	LC_EL("\30YN. FAX SMS")
        LC_HU("FAX SMS Riasztas")
// WARNING: len 15 chars, 30 bytes is higher than 14 chars
        LC_RU("\204\10\37\200\0\106\0\101\0\130\0\40\0\123\0\115\0\123\0\40\4\102\4\100\4\65\4\62\4\76\4\63\4\60")
        LC_END
};

lc_char PROGMEM lc_FAX_SMS_Help[]={
        LC_EN("Emulate alert call with sending SMS as FAX. Operator needs to provide SMS->FAX service. Contact operator on format of SMS and number to use.")
//TODO        LC_FR("Si actif, le SMS contiendra une info de localisation en binaire pour \"AA Locate\" qui rendra l'info lisible.")
//TODO        LC_NO("Hvis denne er valgt, vil SMS inneholde informasjon for lokalisering")
        LC_CZ("Pouzitim sluzby SMS->FAX lze vyvolat vystrazne volani. Operator musi tuto sluzbu poskytovat, kontaktujte ho pro informaci o formatu SMS a cisle sluzby.")
//TODO  	LC_DE("Bei dieser Einstellung werden abgeschickte SMS im Format fur Aplikation \"AA Lokalisieren\" fur Umwandlung der Lokalisationsinformationen in die Adresse umgewandelt.") 
	LC_EL("MHNYMA \30YNA\23EPMOY A\26O\30TE\24\24OMENO \25\30 FAX, A\26AITEITAI ANA\24O\23H \26APOXH Y\26HPE\30IA\30 A\26O TON \26APOXO KINHTH\30 TH\24E\22\25NIA\30 KAI A\26O THN \30Y\30KEYH.")
	LC_HU("Szolgaltatas lehet\134vel teszi az SMSt FAX szamra k~ld\5st, ha az operat\134r a szolgaltatot tamogattya.")
// WARNING: len 184 chars, 368 bytes - longer that 240 bytes
//       LC_RU("\204\10\561\200\4\55\4\74\4\103\4\73\4\70\4\100\4\76\4\62\4\60\4\102\4\114\0\40\4\102\4\100\4\65\4\62\4\76\4\66\4\75\4\113\4\71\0\40\4\67\4\62\4\76\4\75\4\76\4\72\0\40\4\77\4\100\4\70\0\40\4\77\4\76\4\74\4\76\4\111\4\70\0\40\4\76\4\102\4\77\4\100\4\60\4\62\4\72\4\70\0\40\0\123\0\115\0\123\0\40\4\72\4\60\4\72\0\40\0\106\0\101\0\130\0\56\0\40\4\24\4\60\4\75\4\75\4\60\4\117\0\40\4\104\4\103\4\75\4\72\4\106\4\70\4\117\0\40\4\102\4\100\4\65\4\61\4\103\4\65\4\102\0\40\4\75\4\60\4\73\4\70\4\107\4\70\4\65\0\40\4\103\4\101\4\73\4\103\4\63\4\70\0\40\0\123\0\115\0\123\0\55\0\76\0\106\0\101\0\130\0\56\0\40\4\24\4\73\4\117\0\40\4\103\4\102\4\76\4\107\4\75\4\65\4\75\4\70\4\117\0\40\4\104\4\76\4\100\4\74\4\60\4\102\4\60\0\40\0\123\0\115\0\123\0\40\4\70\0\40\4\75\4\76\4\74\4\65\4\100\4\60\0\40\4\102\4\65\4\73\4\65\4\104\4\76\4\75\4\60\0\40\4\101\4\62\4\117\4\66\4\70\4\102\4\65\4\101\4\114\0\40\4\101\4\76\0\40\4\101\4\62\4\76\4\70\4\74\0\40\4\76\4\77\4\65\4\100\4\60\4\102\4\76\4\100\4\76\4\74\0\56")

        LC_END
};


#ifdef CONFIG_TSMS

lc_char PROGMEM lc_Number_Send_Turbo_SMS_Alarm[]={
        LC_EN("Use Turbo SMS")
        LC_FR("Utiliser Turbo SMS")
        LC_NO("Benytt Turbo SMS")
        LC_CZ("Pouzit TSMS")
	LC_DE("TSMS benutzen")
// TODO EL LONG
	LC_EL("XPH\30IMO\26OIH\30TE TURBO SMS")
	LC_HU("TSMS hasznalas")

// WARNING: len 22 chars, 44 bytes is higher than 14 chars
// LC_RU("\204\10\55\200\4\30\4\101\4\77\4\76\4\73\4\114\4\67\4\76\4\62\4\60\4\102\4\114\0\40\0\124\0\165\0\162\0\142\0\157\0\40\0\123\0\115\0\123")

        LC_END
};

lc_char PROGMEM lc_Number_Send_Turbo_SMS_Alarm_Help[]={
        LC_EN("If selected then SMS sent have location information in binary format for \"AA Locate\" application for address substitution.")
        LC_FR("Si actif, le SMS contiendra une info de localisation en binaire pour \"AA Locate\" qui rendra l'info lisible.")
        LC_NO("Hvis denne er valgt, vil SMS inneholde informasjon for lokalisering")
        LC_CZ("Pri nastaveni budou odesilane SMS ve formatu pro aplikaci \"AA Lokalizuj\" pro prevod lokalizacni informace na adresu.")
  	LC_DE("Bei dieser Einstellung werden abgeschickte SMS im Format fur Aplikation \"AA Lokalisieren\" fur Umwandlung der Lokalisationsinformationen in die Adresse umgewandelt.") 
	LC_HU("Beallitasnal az SMS binaris formatumba van k~ldve  a \"AA Locate\" felhasznalasra.")

// WARNING: len 154 chars, 308 bytes is higher than 240 bytes
//LC_RU("\204\10\465\200\4\25\4\101\4\73\4\70\0\40\4\62\4\113\4\61\4\100\4\60\4\75\4\76\0\54\0\40\4\102\4\76\0\40\4\76\4\102\4\77\4\100\4\60\4\62\4\73\4\117\4\65\4\74\4\76\4\65\0\40\0\123\0\115\0\123\0\55\4\101\4\76\4\76\4\61\4\111\4\65\4\75\4\70\4\65\0\40\4\61\4\103\4\64\4\65\4\102\0\40\4\101\4\76\4\64\4\65\4\100\4\66\4\60\4\102\4\114\0\40\4\70\4\75\4\104\4\76\4\100\4\74\4\60\4\106\4\70\4\116\0\40\4\76\0\40\4\74\4\65\4\101\4\102\4\60\4\75\4\60\4\105\4\76\4\66\4\64\4\65\4\75\4\70\4\70\0\40\4\62\0\40\4\64\4\62\4\76\4\71\4\107\4\75\4\76\4\74\0\40\4\62\4\70\4\64\4\65\0\40\4\64\4\73\4\117\0\40\4\77\4\76\4\64\4\101\4\102\4\60\4\75\4\76\4\62\4\72\4\70\0\40\4\60\4\64\4\100\4\65\4\101\4\60\0\40\4\62\0\40\4\77\4\100\4\70\4\73\4\76\4\66\4\65\4\75\4\70\4\70\0\40\0\134\0\42\0\101\0\101\0\40\0\114\0\157\0\143\0\141\0\164\0\145\0\134\0\42")

// TODO LC_EL
        LC_END
};
#endif

lc_char PROGMEM lc_Number_Call_Alarm[]={
        LC_EN("Call Alarm")
        LC_FR("Appel Alarme")
	LC_NO("Alarm Oppkall")
        LC_CZ("Volat alarm")
  	LC_DE("Alarm anrufen") 
	LC_EL("\30YNA\23EPMO\30 K\24H\30H\30")
	LC_HU("Riaszt hivas")
        LC_END
};


lc_char PROGMEM lc_Number_Status[]={
        LC_EN("Report State")
        LC_FR("Rapport de status")
	LC_NO("Status Rapport")
  	LC_DE("Zustand melden") 
        LC_CZ("Hlasit stav")
	LC_EL("ANA\22OPA KATA\30TA\30H\30")
	LC_HU("Sztatus jelz\5s")

// WARNING: len 18 chars, 36 bytes is higher than 14 chars
LC_RU("\204\10\45\200\4\41\4\76\4\76\4\61\4\111\4\60\4\102\4\114\0\40\4\101\4\76\4\101\4\102\4\76\4\117\4\75\4\70\4\65")

        LC_END
};

lc_char PROGMEM lc_Number_SMS_Onoff[]={
        LC_EN("SMS Control")
        LC_FR("Controle par SMS")
	LC_NO("SMS Kontroll")
        LC_DE("SMS Bedienen")
        LC_CZ("Ovladat SMS")
	LC_EL("SMS \20IAXEIPI\30H\30")
	LC_HU("SMS beallitas")

// WARNING: len 17 chars, 34 bytes is higher than 14 chars
LC_RU("\204\10\43\200\4\43\4\77\4\100\4\60\4\62\4\73\4\65\4\75\4\70\4\65\0\40\4\77\4\76\0\40\0\123\0\115\0\123")

        LC_END
};

  	//LC_DE("TODO") 
        //LC_NO("Auto Alarm kan kontrolleres via SMS kommandoer. Benytt \"ON\" for alarm på, \"OFF\" for av and \"ALARM OFF\" for alarm kansellering.")
lc_char PROGMEM lc_Number_SMS_Onoff_Help[]={
        LC_EN("Auto Alarm can be controlled by SMS commands. Use \"ON\" for turning alarm on, \"OFF\" for off and \"ALARM OFF\" for alarm cancelation.")
        LC_FR ("Auto Alarme peut tre control\5 par SMS. Utiliser \"ON\" et \"OFF\" pour activer ou d\5sactiver une alarme. \"ALARM OFF\" pour annuler.")
        LC_NO("Auto Alarm kan kontrolleres via SMS kommandoer. Benytt \"ON\" for alarm pa, \"OFF\" for av and \"ALARM OFF\" for alarm kansellering.")
        LC_CZ("Auto Alarm lze ovladat SMS prikazy. \"ON\" pro zapnuti alarmu, \"OFF\" pro vypnuti a \"ALARM OFF\" pro odvolani pripadneho existujiciho alarmu.")
	LC_EL("TO AUTO ALARM \20EXETAI MHNYMATA ENTO\24\25N SMS. H ENTO\24H \"ON\" ENEP\23O\26OIEI KAI H ENTO\24H \"OFF\" TON A\26ENEP\23O\26OIEI TON \30YNA\23EPMO, H ENTO\24H \"ALARM OFF\" E\26ANA\22EPEI TON \30YNA\23EPMO \30E KATA\30TA\30H ANAMONH\30.")
	LC_HU("Auto Riaszto SMS parancsokkal bealithato. \"ON\" Bekapcs, \"OFF\" Kikapcs es \"ALARM OFF\" ujra inditas riasztas utan.")

// WARNING: len 156 chars, 312 bytes is higher than 240 bytes
//LC_RU("\204\10\471\200\0\101\0\165\0\164\0\157\0\40\0\101\0\154\0\141\0\162\0\155\0\40\4\74\4\76\4\66\4\75\4\76\0\40\4\103\4\77\4\100\4\60\4\62\4\73\4\117\4\102\4\114\0\40\4\77\4\100\4\70\0\40\4\77\4\76\4\74\4\76\4\111\4\70\0\40\0\123\0\115\0\123\0\55\4\72\4\76\4\74\4\60\4\75\4\64\0\56\0\40\4\30\4\101\4\77\4\76\4\73\4\114\4\67\4\103\4\71\4\102\4\65\0\40\0\134\0\42\0\117\0\116\0\134\0\42\0\40\4\64\4\73\4\117\0\40\4\77\4\76\4\101\4\102\4\60\4\75\4\76\4\62\4\72\4\70\0\40\4\75\4\60\0\40\4\76\4\105\4\100\4\60\4\75\4\103\0\54\0\40\0\134\0\42\0\117\0\106\0\106\0\134\0\42\0\40\4\64\4\73\4\117\0\40\4\101\4\75\4\117\4\102\4\70\4\117\0\40\4\101\0\40\4\76\4\105\4\100\4\60\4\75\4\113\0\40\0\134\0\42\0\101\0\114\0\101\0\122\0\115\0\40\0\117\0\106\0\106\0\134\0\42\0\40\4\64\4\73\4\117\0\40\4\76\4\102\4\74\4\65\4\75\4\113\0\40\4\102\4\100\4\65\4\62\4\76\4\63\4\70\0\56")

        LC_END
};

lc_char PROGMEM lc_Number_Call_Onoff[]={
        LC_EN("Call Control")
        LC_FR("Controle appel")
	LC_NO("Ringe Kontroll")
  	LC_DE("Tel. Bedienen") 
        LC_CZ("Ovl. volanim")
	LC_EL("E\24E\23XO\30 K\24H\30H\30")
	LC_HU("Hivassal beallit")

// WARNING: len 18 chars, 36 bytes is higher than 14 chars
LC_RU("\204\10\45\200\4\43\4\77\4\100\4\60\4\62\4\73\4\65\4\75\4\70\4\65\0\40\4\67\4\62\4\76\4\75\4\72\4\76\4\74")

        LC_END
};

//	LC_NO("Bekr. telef. på")
lc_char PROGMEM lc_Number_Call_Confirm[]={
        LC_EN("Conf. Call On")
        LC_FR("Confirm. appel actif")
	LC_NO("Bekr. telef. pa")
  	LC_DE("Tel. Bed. bestatigen") 
        LC_CZ("Potv. zap.vol.")
// TODO EL LONG
	LC_EL("E\26IBEBAI\25\30H K\24H\30H\30")
	LC_HU("Hivasal Bekapcs")

// WARNING: len 31 chars, 62 bytes is higher than 14 chars
LC_RU("\204\10\77\200\4\37\4\76\4\64\4\102\4\62\4\65\4\100\4\66\4\64\4\65\4\75\4\70\4\65\0\40\4\60\4\72\4\102\4\70\4\62\4\60\4\106\4\70\4\70\0\40\4\67\4\62\4\76\4\75\4\72\4\76\4\74")

        LC_END
};

lc_char PROGMEM lc_Minutes[]={
        LC_EN("Minutes:")
	LC_NO("Minutter:")
        LC_DE("Minuten:")
        LC_CZ("Minut:")
	LC_EL("\24E\26TA:")
	LC_HU("Perc:")
LC_RU("\204\10\17\200\4\34\4\70\4\75\4\103\4\102\4\113\0\72")
        LC_END
};

lc_char PROGMEM lc_Seconds[]={
        LC_EN("Seconds:")
        LC_FR("Secondes:")
        LC_NO("Sekunder:")
 	LC_CZ("Sekund:")
        LC_DE("Sekunden:")
	LC_EL("\20EYTEPO\24E\26TA:")
	LC_HU("Mperc:")
LC_RU("\204\10\21\200\4\41\4\65\4\72\4\103\4\75\4\64\4\113\0\72")
        LC_END
};


	//LC_NO("Sentrallås")
lc_char PROGMEM lc_Central_lock[]={
        LC_EN("Central lock.")
        LC_FR("Verrouillage central.")
	LC_NO("Sentrallas")
        LC_DE("Zentralverri.")
        LC_CZ("Cent. zamykani")
	LC_EL("KENTPIKO K\24EI\20\25MA")
	LC_HU("K|zponti zaras")
// WARNING: len 18 chars, 36 bytes is higher than 14 chars
LC_RU("\204\10\45\200\4\46\4\65\4\75\4\102\4\100\4\60\4\73\4\114\4\75\4\113\4\71\0\40\4\67\4\60\4\74\4\76\4\72\0\56")

        LC_END
};

lc_char PROGMEM lc_Alarm_1[]={
        LC_EN("Alarm #1")
	LC_FR("Alarme #1")
	LC_EL("\30YNA\23EPMO\30 1")
	LC_HU("Riasztas #1")
LC_RU("\204\10\25\200\4\42\4\100\4\65\4\62\4\76\4\63\4\60\0\40\0\43\0\61")
        LC_END
};

lc_char PROGMEM lc_Alarm_2[]={
        LC_EN("Alarm #2")
	LC_FR("Alarme #2")
	LC_EL("\30YNA\23EPMO\30 2")
	LC_HU("Riasztas #2")
LC_RU("\204\10\25\200\4\42\4\100\4\65\4\62\4\76\4\63\4\60\0\40\0\43\0\62")
        LC_END
};

	//LC_NO("Måling")
lc_char PROGMEM lc_Measure[]={
        LC_EN("Measure")
        LC_FR("Mesure")
	LC_NO("Maeling")
        LC_CZ("Mereni")
  	LC_DE("Messung") 
	LC_EL("METPH\30H")
	LC_HU("M\5r\5s")
LC_RU("\204\10\23\200\4\30\4\67\4\74\4\65\4\100\4\65\4\75\4\70\4\65")
        LC_END
};

lc_char PROGMEM lc_Measure_Help[]={
        LC_EN("Measure accelerometer values. For demonstration purpose. Display refresh depends on the used mobile phone.")
	LC_FR("Mesure du detecteur de mouvements pour d\5monstration. Affichage d\5pendant du GSM utili\5.")
	LC_NO("Measure accelerometer values. For demonstration purpose. Display refresh depends on the used mobile phone.")
        LC_CZ("Mereni hodnot akcelerometru. Pouze pro demonstraci. Rychlost opakovani a zobrazovani na displej zavisi na pouzitem telefonu.")
  	LC_DE("Messung der Beschleunigungswerte. Nur zur Demonstration. Die Wiederholungsgeschwindigkeit  und die Darstellung auf dem Display hät vom jeweils benutzten Mobiltelefon ab.") 
	LC_EL("METPH\30H E\26ITAXYN\30H\30. \23IA E\26I\20EI\32H MONO. H ANANE\25\30H T\25N METPH\30E\25N E\32APTATAI A\26O TH \30Y\30KEYH \26OY XPH\30IMO\26OIEITE.")
	LC_HU("Akcelero \5rz\5kel\134 kimenet m\5r\5se - DEMO modban. M\5res idej\5t a hasznalt telefon befolyasolja.")
LC_RU("\204\10\247\200\4\30\4\67\4\74\4\65\4\100\4\65\4\75\4\70\4\65\0\40\4\77\4\76\4\72\4\60\4\67\4\60\4\75\4\70\4\71\0\40\4\64\4\60\4\102\4\107\4\70\4\72\4\60\0\40\4\62\4\70\4\61\4\100\4\60\4\106\4\70\4\70\0\56\0\40\4\47\4\60\4\101\4\102\4\76\4\102\4\60\0\40\4\76\4\61\4\75\4\76\4\62\4\73\4\65\4\75\4\70\4\117\0\40\4\67\4\60\4\62\4\70\4\101\4\70\4\102\0\40\4\76\4\102\0\40\4\74\4\76\4\64\4\65\4\73\4\70\0\40\4\102\4\65\4\73\4\65\4\104\4\76\4\75\4\60")

        LC_END
};

lc_char PROGMEM lc_Poll_Interval[]={
        LC_EN("Poll Interval")
	LC_FR("Int. de mesure")
	LC_NO("Test Intervall")
        LC_CZ("Int. mereni")
  	LC_DE("Messintervall") 
	LC_EL("XPONO\30 \30AP\25\30H\30")
	LC_HU("M\5r\5s ciklus")
// WARNING: len 15 chars, 30 bytes is higher than 14 chars
LC_RU("\204\10\37\200\4\30\4\75\4\102\4\65\4\100\4\62\4\60\4\73\0\40\4\76\4\77\4\100\4\76\4\101\4\60")

        LC_END
};

lc_char PROGMEM lc_Poll_Interval_Error[]={
        LC_EN("Cannot set Poll Interval, 30 sec used.")
	LC_FR("Ne peut appliquer cet intervalle, 30 secs par d\5faut")
	LC_NO("Kan ikke sette test intervall, 30 sek benyttes.")
        LC_CZ("Nelze nastavit interval mereni, pouzito 30 sekund.")
  	LC_DE("Den Messintervall ist nicht einstellbar, er betrag immer 30 Sekunden.") 
	LC_EL("A\24\24A\23H \30AP\25\30H\30 A\20YNATH, XPH\30H 30 \20EYTEPO\24E\26TA.")
	LC_HU("Nem bealithato a m\5r\5s ciklus, bealitot 30 mp.")
LC_RU("\204\10\167\200\4\35\4\65\4\62\4\76\4\67\4\74\4\76\4\66\4\75\4\76\0\40\4\103\4\101\4\102\4\60\4\75\4\76\4\62\4\70\4\102\4\114\0\40\4\70\4\75\4\102\4\65\4\100\4\62\4\60\4\73\0\40\4\76\4\77\4\100\4\76\4\101\4\60\0\54\0\40\4\70\4\101\4\77\4\76\4\73\4\114\4\67\4\103\4\65\4\102\4\101\4\117\0\40\0\63\0\60\0\40\4\101\4\65\4\72\0\56")
        LC_END
};

lc_char PROGMEM lc_Help_Poll_Interval[]={
        LC_EN("Poll Interval defines interval between measurements and inputs checking for alarm detection. In seconds, phone can use approximate value.")
	LC_FR("Intervalle de mesure d\5finit le temps entre les mesures des entr\5es pour la d\5tection des alarmes. En secondes. Approximatif en fonction du GSM utilis")
	LC_NO("Test intervall definerer tiden mellom hver test av sensorer. i sekunder, benytt ca. verdier.")
        LC_CZ("Interval mereni rika, jak casto se meri hodnota akcelerometru a vstupu pro detekci alarmu. Udava se v sekundach, telefon muze zvolit pribliznou hodnotu.")
  	LC_DE("Der Messintervall definiert wie oft der Beschleunigungsmesser und der Alarmeingang gemessen werden. Diese wird in Sekunden angegeben und kann je nach Mobiltelefon um einige Sekunden schwanken.") 
	LC_EL("O XPONO\30 \30AP\25\30H\30 OPIZEI TO XPONIKO \20IA\30THMA META\32Y TON METPH\30E\25N KAI E\24E\23X\25N T\25N EI\30O\20\25N \23IA \20IA\23N\25\30H KATA\30TA\30H\30 \30YNA\23EPMOY \30E \20EYTEPO\24E\26TA, H \30Y\30KEYH \31A XPH\30IMO\26OIH\30EI XPONOY\30 KATA \26PO\30E\23\23I\30H.")
	LC_HU("Bealitot ciklus az akcelero \5rz\5kel\134 \5rt\5ket m\5ri bealitot mp-k\5nt. Az telefon tipusatol f~gve lehetnek elteresek.")
// WARNING: len 157 chars, 314 bytes is higher than 240 bytes
//LC_RU("\204\10\473\200\4\30\4\75\4\102\4\65\4\100\4\62\4\60\4\73\0\40\4\76\4\77\4\100\4\76\4\101\4\60\0\40\4\76\4\77\4\100\4\65\4\64\4\65\4\73\4\117\4\65\4\102\0\40\4\70\4\75\4\102\4\65\4\100\4\62\4\60\4\73\0\40\4\74\4\65\4\66\4\64\4\103\0\40\4\70\4\67\4\74\4\65\4\100\4\65\4\75\4\70\4\117\4\74\4\70\0\40\4\70\0\40\4\77\4\100\4\76\4\62\4\65\4\100\4\72\4\70\0\40\4\62\4\105\4\76\4\64\4\76\4\62\0\40\4\77\4\100\4\70\0\40\4\76\4\61\4\75\4\60\4\100\4\103\4\66\4\65\4\75\4\70\4\70\0\40\4\102\4\100\4\65\4\62\4\76\4\63\4\70\0\56\0\40\4\22\0\40\4\101\4\65\4\72\4\103\4\75\4\64\4\60\4\105\0\54\0\40\4\102\4\65\4\73\4\65\4\104\4\76\4\75\0\40\4\74\4\76\4\66\4\65\4\102\0\40\4\70\4\101\4\77\4\76\4\73\4\114\4\67\4\76\4\62\4\60\4\102\4\114\0\40\4\77\4\100\4\70\4\61\4\73\4\70\4\66\4\65\4\75\4\75\4\113\4\65\0\40\4\67\4\75\4\60\4\107\4\65\4\75\4\70\4\117")

        LC_END
};


lc_char PROGMEM lc_Poll_Interval_Set[]={
        LC_EN("Poll Interval set to ")
	LC_FR("Intervalle de mesure mis a ")
	LC_NO("Test intervall er satt til ")
        LC_CZ("Interval mereni nastaven na ")
  	LC_DE("Messintervall eingestellt auf ") 
	LC_EL("O XPONO\30 \30AP\25\30H\30 OPI\30TIKE \30E ")
	LC_HU("M\5r\5s ciklus beallitva ")
LC_RU("\204\10\73\200\4\30\4\75\4\102\4\65\4\100\4\62\4\60\4\73\0\40\4\76\4\77\4\100\4\76\4\101\4\60\0\40\4\103\4\101\4\102\4\60\4\75\4\76\4\62\4\73\4\65\4\75\0\40\4\62\0\40") 
        LC_END
};

lc_char PROGMEM lc_Seconds_2[]={
        LC_EN(" seconds.")
	LC_FR(" secondes.")
	LC_NO(" Sekunder.")
        LC_CZ(" sekund.")
  	LC_DE(" Sekunden.") 
	LC_EL(" \20EYTEPO\24E\26TA.")
	LC_HU(" mp.")
LC_RU("\204\10\21\200\0\40\4\101\4\65\4\72\4\103\4\75\4\64\0\56")

        LC_END
};

#ifdef CONFIG_BLOCK
lc_char PROGMEM lc_Number_Block[]={
        LC_EN("Block")
	LC_FR("Bloquer")
	LC_NO("Blokker")
        LC_DE("Blockieren")
        LC_CZ("Blokace")
	LC_EL("M\26\24OKAPI\30E")
	LC_HU("Lealitas")
LC_RU("\204\10\25\200\4\21\4\73\4\76\4\72\4\70\4\100\4\76\4\62\4\72\4\60")
        LC_END
};
#endif

#ifdef CONFIG_AIRCON
lc_char PROGMEM lc_Number_Aircon[]={
        LC_EN("Aircon")
	LC_FR("Climatisation")
        LC_DE("Klimaanlage")
        LC_CZ("Klimatizace")
	LC_EL("K\24IMATI\30MO\30")
	LC_HU("Klimatizacio")
LC_RU("\204\10\27\200\4\32\4\76\4\75\4\64\4\70\4\106\4\70\4\76\4\75\4\65\4\100")

        LC_END
};
#endif

	//LC_NO("Språk")
lc_char PROGMEM lc_Lang[]={
        LC_EN("Language")
	LC_FR("Langue")
	LC_NO("Sprak")
        LC_DE("Sprache")
        LC_CZ("Jazyk")
	LC_EL("\23\24\25\30\30A")
	LC_HU("Nyelv")
LC_RU("\204\10\11\200\4\57\4\67\4\113\4\72")
        LC_END
};

lc_char PROGMEM lc_Sensitivity[]={
        LC_EN("Sensitivity")
	LC_FR("Sensibilit\5")
	LC_NO("Sensitivitet")
        LC_DE("Empfindlichkeit")
        LC_CZ("Citlivost")
	LC_EL("EYAI\30\31H\30IA")
	LC_HU("\37rz\5kenys\5g")
// WARNING: len 16 chars, 32 bytes is higher than 14 chars
LC_RU("\204\10\41\200\4\47\4\103\4\62\4\101\4\102\4\62\4\70\4\102\4\65\4\73\4\114\4\75\4\76\4\101\4\102\4\114")

        LC_END
};

lc_char PROGMEM lc_Baudrate[]={
        LC_EN("Baudrate")
	LC_HU("Baud sebess\5g")
	LC_RU("\204\10\23\200\4\40\4\65\4\61\4\65\4\75\4\76\4\72\0\72\0\40")
        LC_END
};

lc_char PROGMEM lc_NmeaInterval[]={
        LC_EN("NMEA Intreval")
	LC_HU("NMEA ciklus")
        LC_END
};

lc_char PROGMEM lc_InitGps[]={
        LC_EN("Clear GPS")
	LC_HU("T|r|ld GPSt")
        LC_END
};

lc_char PROGMEM lc_Read[]={
        LC_EN("Read")
	LC_HU("Olvas")
        LC_END
};

	//LC_NO("Forsinkelse på")
lc_char PROGMEM lc_Manual_Delay_On[]={
        LC_EN("Delay Man. On")
	LC_FR("D\5lai Activat.")
	LC_NO("Forsinkelse Pa")
        LC_DE("Man.Ein.verzo.")
        LC_CZ("Prodleva zap.")
	LC_EL("XEIP. KA\31. ON")
	LC_HU("Bekapcs k\5sl.")
// WARNING: len 29 chars, 58 bytes is higher than 14 chars
LC_RU("\204\10\73\200\4\27\4\60\4\64\4\65\4\100\4\66\4\72\4\60\0\40\4\77\4\100\4\70\0\40\4\100\4\103\4\107\4\75\4\76\4\71\0\40\4\60\4\72\4\102\4\70\4\62\4\60\4\106\4\70\4\70")

        LC_END
};

lc_char PROGMEM lc_Manual_Delay_Off[]={
        LC_EN("Delay Man. Off")
	LC_FR("D\5lai D\5sact.")
	LC_NO("Forsinkelse Av")
        LC_DE("Man.Aus.verzo.")
        LC_CZ("Prodleva vyp.")
	LC_EL("XEIP. KA\31. OFF")
	LC_HU("Kikapcs k\5sl.")
// WARNING: len 31 chars, 62 bytes is higher than 14 chars
LC_RU("\204\10\77\200\4\27\4\60\4\64\4\65\4\100\4\66\4\72\4\60\0\40\4\77\4\100\4\70\0\40\4\100\4\103\4\107\4\75\4\76\4\71\0\40\4\64\4\65\4\60\4\72\4\102\4\70\4\62\4\60\4\106\4\70\4\70")

        LC_END
};

        //LC_DE("TODO")
lc_char PROGMEM lc_Repeat_Alarm_SMS[]={
        LC_EN("Repeated Alarm")
	LC_FR("Alarme r\5p\5t\5e")
	LC_NO("Repetert Alarm")
        LC_CZ("Opakovat alarm")
	LC_EL("E\26. \30YNA\23EPMO\30")
	LC_HU("Ismetelt riasztas")
// WARNING: len 18 chars, 36 bytes is higher than 14 chars
LC_RU("\204\10\45\200\4\37\4\76\4\62\4\102\4\76\4\100\4\65\4\75\4\70\4\65\0\40\4\102\4\100\4\65\4\62\4\76\4\63\4\70")

        LC_END
};

        //LC_DE("TODO")
lc_char PROGMEM lc_Delay[]={
        LC_EN("Delay")
	LC_FR("D\5lai")
	LC_NO("Forsinkelse")
        LC_CZ("Prodleva")
	LC_EL("KA\31Y\30TEPH\30H")
	LC_HU("K\5sleltet\5s")
	LC_RU("\204\10\21\200\4\27\4\60\4\64\4\65\4\100\4\66\4\72\4\60")
        LC_END
};

        //LC_DE("TODO")
lc_char PROGMEM lc_Help_Repeat_SMS[]={
        LC_EN("Setting for repeated Alarm SMS sending when movement, in minutes, 0 means only one SMS will be sent.")
	LC_FR("D\5lai pour la r\5p\5tition des alarmes, en minutes. 0 signifie un seul SMS.")
	LC_NO("Sett tidsintervall for repeterte meldinger. 0 er en melding pr. alarm")
        LC_CZ("Nastaveni pro opakovane posilani vystrazne SMS pri pohybu, udava se prodleva v minutach, 0 znamena odeslani pouze jedne SMS.")
	LC_EL("O OPI\30MO\30 TOY E\26ANA\24AMBANOMENOY \30YNA\23EPMOY KAI THN A\26O\30TO\24H MHNYMAT\25N SMS OPIZETAI \30E \24E\26TA, 0 \30HMAINEI \26\25\30 MONO ENA MHNYMA SMS \31A \30TA\24EI.")
	LC_HU("A riaszto ismetelt SMS kuldes ciklusanak beallitasa a mozgas riasztasnal.  A 0 \5rt\5k beallitasnal csak egy SMS k~ld a megadott szamra.")
	LC_RU("\204\10\211\200\4\25\4\101\4\73\4\70\0\40\4\103\4\101\4\102\4\60\4\75\4\76\4\62\4\70\4\102\4\114\0\40\0\60\0\40\4\74\4\70\4\75\4\103\4\102\0\54\0\40\4\61\4\103\4\64\4\65\4\102\0\40\4\76\4\102\4\77\4\100\4\60\4\62\4\73\4\65\4\75\4\76\0\40\4\102\4\76\4\73\4\114\4\72\4\76\0\40\4\76\4\64\4\75\4\76\0\40\0\123\0\115\0\123\0\40\4\101\4\76\4\76\4\61\4\111\4\65\4\75\4\70\4\65\0\56")

        LC_END
};

lc_char PROGMEM lc_Help[]={
        LC_EN("Help")
	LC_FR("Aide")
	LC_NO("Hjelp")
        LC_DE("Hilfe")
        LC_CZ("Napoveda")
	LC_EL("BOH\31EIA")
	LC_HU("Sugo")
	LC_RU("\204\10\15\200\4\37\4\76\4\74\4\76\4\111\4\114")
        LC_END
};


lc_char PROGMEM lc_Clear_SIM_SMS[]={
        LC_EN("Clear SIM SMS")
	LC_FR("Sup. SMS SIM")
	LC_NO("Slett SIM SMS")
        LC_DE("SIM SMS loschen")
        LC_CZ("Smazat SIM SMS")
	LC_EL("\30BH\30E MNHMH SIM SMS")
	LC_HU("T|r|ld SIM SMS")

	// WARNING: len 16 chars, 32 bytes is higher than 14 chars
	LC_RU("\204\10\41\200\4\36\4\107\4\70\4\101\4\102\4\70\4\102\4\114\0\40\0\123\0\111\0\115\0\40\0\123\0\115\0\123")
        LC_END
};

#ifdef CONFIG_NET_RESET
lc_char PROGMEM lc_Network_Reset[]={
        LC_EN("Network Reset")
	LC_FR("Init. R\5seau")
	LC_NO("Network Reset")
        LC_CZ("Reset site")
	LC_EL("E\26ANA\22OPA \20IKTYOY")
	LC_HU("Halozat t|rl\5s")
	LC_RU("\204\10\25\200\4\41\4\61\4\100\4\76\4\101\0\40\4\101\4\65\4\102\4\70")
        LC_END
};
#endif

lc_char PROGMEM lc_Version[]={
        LC_EN("Version")
	LC_FR("Version")
	LC_NO("Versjon")
        LC_DE("Version")
        LC_CZ("Verze")
	LC_EL("EK\20O\30H")
	LC_HU("Verzio")
	LC_RU("\204\10\15\200\4\22\4\65\4\100\4\101\4\70\4\117")
        LC_END
};

lc_char PROGMEM lc_Version_baby[]={
        LC_EN("Baby: ")
	LC_RU("\204\10\23\200\4\40\4\65\4\61\4\65\4\75\4\76\4\72\0\72\0\40")
        LC_END
};

#if 0
lc_char PROGMEM lc_Yes[]={
        LC_EN("  Yes")
	LC_FR("  Oui")
	LC_NO("  Ja")
	LC_DE("  Ja")
        LC_CZ("  Ano")
	LC_EL("  NAI")
	LC_HU("  Igen")
	LC_RU("\204\10\11\200\0\40\0\40\4\24\4\60")
        LC_END
};

lc_char PROGMEM lc_No[]={
        LC_EN("  No")
	LC_FR("  Non")
	LC_NO("  Nei")
	LC_DE("  Nein")
        LC_CZ("  Ne")
	LC_EL("  OXI")
	LC_HU("  Nem")
	LC_RU("\204\10\13\200\0\40\0\40\4\35\4\65\4\102")
        LC_END
};
#endif

lc_char PROGMEM lc_SMS_Yes[]={
        LC_EN("Yes")
	LC_FR("Oui")
	LC_NO("Ja")
	LC_DE("Ja")
        LC_CZ("Ano")
//	LC_EL("NAI")
	LC_HU("Igen")
	LC_RU("\204\10\5\200\4\24\4\60")
        LC_END
};

lc_char PROGMEM lc_SMS_No[]={
        LC_EN("No")
	LC_FR("Non")
	LC_NO("Nei")
	LC_DE("Nein")
        LC_CZ("Ne")
//	LC_EL("OXI")
	LC_HU("Nem")
	LC_RU("\204\10\7\200\4\35\4\65\4\102")
        LC_END
};

lc_char PROGMEM lc_Wrong_PIN[]={
        LC_EN("Wrong PIN")
	LC_FR("Mauvais PIN")
	LC_NO("Feil PIN")
        LC_DE("Falsche PIN")
        LC_CZ("Spatny PIN")
	LC_EL("\24A\31O\30 PIN")
	LC_HU("Hibas PIN")
	LC_RU("\204\10\31\200\4\35\4\65\4\62\4\65\4\100\4\75\4\113\4\71\0\40\0\120\0\111\0\116")

        LC_END
};

lc_char PROGMEM lc_Protect_PIN[]={
        LC_EN("PIN Protected")
	LC_FR("Prot\5g\5 PIN")
	LC_NO("PIN Beskyttet")
        LC_DE("PIN schutzen")
        LC_CZ("Chranit PIN")
	LC_EL("\20\25\30TE PIN")
	LC_HU("PIN-el v\5dve")
	LC_RU("\204\10\31\200\4\27\4\60\4\111\4\70\4\111\4\65\4\75\4\76\0\40\0\120\0\111\0\116")

        LC_END
};

lc_char PROGMEM lc_Enter_PIN[]={
        LC_EN("Enter PIN")
	LC_FR("Entrez PIN")
	LC_NO("Enter PIN")
        LC_DE("PIN eingeben")
        LC_CZ("Vlozte PIN")
	LC_EL("\20\25\30TE PIN")
	LC_HU("Kerem a PIN")
	LC_RU("\204\10\27\200\4\22\4\62\4\65\4\64\4\70\4\102\4\65\0\40\0\120\0\111\0\116")

        LC_END
};

lc_char PROGMEM lc_SMS_Alarm_Accel[]={
        LC_EN("ALARM: Movement !\n")
	LC_FR("ALARME: Mouvement !\n")
	LC_NO("ALARM: Bevegelse !\n")
        LC_DE("ALARM: Bewegung !\n")
        LC_CZ("ALARM: Pohyb !\n")
//	LC_EL("\30YNA\23EPMO\30: KINH\30H\30 !\n")
	LC_HU("Riaszt: Mozgas !\n")
	LC_RU("\204\10\53\200\4\42\4\40\4\25\4\22\4\36\4\23\4\20\0\72\0\40\4\24\4\62\4\70\4\66\4\65\4\75\4\70\4\65\0\40\0\41\0\134\0\156")

        LC_END
};

lc_char PROGMEM lc_SMS_Alarm_Panic[]={
        LC_EN("ALARM: Panic !\n")
//	LC_FR("ALARME: Mouvement !\n")
//	LC_NO("ALARM: Bevegelse !\n")
//        LC_DE("ALARM: Bewegung !\n")
        LC_CZ("ALARM: Pomoc !\n")
//	LC_EL("\30YNA\23EPMO\30: KINH\30H\30 !\n")
	LC_HU("Riaszt: Panika !\n")
	LC_RU("\204\10\47\200\4\42\4\40\4\25\4\22\4\36\4\23\4\20\0\72\0\40\4\37\4\60\4\75\4\70\4\72\4\60\0\40\0\41\0\134\0\156")
        LC_END
};

lc_char PROGMEM lc_SMS_Alarm_1[]={
        LC_EN("ALARM #1 !!!\n")
	LC_FR("ALARME #1 !!!\n")
//	LC_EL("\30YNA\23EPMO\30 #1 !!!\n")
	LC_HU("Riaszt #1 !!!\n")
	LC_RU("\204\10\41\200\4\42\4\40\4\25\4\22\4\36\4\23\4\20\0\40\0\43\0\61\0\40\0\41\0\41\0\41\0\134\0\156")

        LC_END
};

lc_char PROGMEM lc_SMS_Alarm_2[]={
        LC_EN("ALARM #2 !!!\n")
	LC_FR("ALARME #2 !!!\n")
//	LC_EL("\30YNA\23EPMO\30 #2 !!!\n")
	LC_HU("Riaszt #2 !!!\n")
	LC_RU("\204\10\41\200\4\42\4\40\4\25\4\22\4\36\4\23\4\20\0\40\0\43\0\62\0\40\0\41\0\41\0\41\0\134\0\156")

        LC_END
};

lc_char PROGMEM lc_Status_Central[]={
        LC_EN("Central: ")
	LC_FR("Centrale: ")
	LC_NO("Sentral: ")
        LC_DE("Zentral: ")
        LC_CZ("Central: ")
//	LC_EL("KENTPIKO\30: ")
	LC_HU("Kozponti zar: ")
	LC_RU("\204\10\33\200\4\46\4\65\4\75\4\102\4\100\4\60\4\73\4\114\4\75\4\113\4\71\0\72\0\40")
        LC_END
};

lc_char PROGMEM lc_SMS_Deleted[]={
        LC_EN("All Messages on SIM Deleted")
	LC_FR("Tous messages SIM effac\5s")
	LC_NO("Alle meldinger pa SIM Slettet")
        LC_DE("Alle Eintrage auf SIM geloscht")
        LC_CZ("Vsechny zpravy na SIM smazany")
	LC_EL("O\24A TA MHNYMATA \30TO SIM \30BH\30THKAN")
	LC_HU("SIM kartyan minden SMS t|r|lve")
	LC_RU("\204\10\71\200\4\22\4\101\4\65\0\40\4\101\4\76\4\76\4\61\4\111\4\65\4\75\4\70\4\117\0\40\4\75\4\60\0\40\0\123\0\111\0\115\0\40\4\103\4\64\4\60\4\73\4\65\4\75\4\113")
        LC_END
};

lc_char PROGMEM lc_Please_Wait[]={
        LC_EN("Please Wait")
	LC_FR("Attendre svp.")
	LC_NO("Vennligst vent")
        LC_DE("Bitte warten")
        LC_CZ("Prosim cekejte")
	LC_EL("\26APAKA\24\25 \26EPIMENETE")
	LC_HU("K\5rem varj")
	LC_RU("\204\10\51\200\4\37\4\76\4\66\4\60\4\73\4\103\4\71\4\101\4\102\4\60\0\40\4\77\4\76\4\64\4\76\4\66\4\64\4\70\4\102\4\65")

        LC_END
};


lc_char PROGMEM lc_Status_Alarm_1[]={
        LC_EN("Alarm#1: ")
	LC_FR("Alarme#1: ")
//	LC_EL("\30YNA\23EPMO\30#1: ")
	LC_HU("Riasztas#1: ")
	LC_RU("\204\10\31\200\4\42\4\100\4\65\4\62\4\76\4\63\4\60\0\40\0\43\0\61\0\72\0\40")

        LC_END
};

lc_char PROGMEM lc_Status_Alarm_2[]={
        LC_EN("Alarm#2: ")
	LC_FR("Alarme#2: ")  
//	LC_EL("\30YNA\23EPMO\30#2: ")
	LC_HU("Riasztas#2: ")
	LC_RU("\204\10\31\200\4\42\4\100\4\65\4\62\4\76\4\63\4\60\0\40\0\43\0\62\0\72\0\40")

        LC_END
};

lc_char PROGMEM lc_SetNew[]={
        LC_EN("Set Interval")
	LC_HU("Ciklus beallitas")
        LC_END
};

/* *INDENT-ON* */

u8 PROGMEM t_gpsData_UTC[] = "UT=";
u8 PROGMEM t_gpsData_LATITUDE[] = "LA=";
u8 PROGMEM t_gpsData_LONGITUDE[] = "LO=";
u8 PROGMEM t_gpsData_SATELLITES[] = "SA=";
u8 PROGMEM t_gpsData_ALTITUDE[] = "AL=";
u8 PROGMEM t_gpsData_COURSE[] = "CR=";
u8 PROGMEM t_gpsData_SPEED[] = "SP=";
u8 PROGMEM t_gpsData_DATE[] = "DA=";

typedef struct _Pers_mem
{
  SEdge *numbers;		// pointer to msisdns
  u8 sens;
  u8 baudrate;
  u8 manual_delay_on;
  u8 manual_delay_off;
  u8 repeated_sms_delay;
  u8 central_lock;
  u8 alarm_1;
  u8 alarm_2;
  u16 net_reset;
  u8 status_spawn_bug;
  u8 pin[4];
  u8 is_pin;
  u8 poll_interval;
  u8 poll_interval_new;
  u8 interval_nmea;
}
Pers_mem;

typedef struct _Number_cap	// number capabilities
{
  u8 *nr;
  u8 alarm;
  u8 alarm_call;
  u8 status;
  u8 call;
  u8 call_confirm;
  u8 sms;
  u8 turbo_sms;
  u8 *fax_sms;			// if fax sms -> don't send other sms, just this one and only once

#ifdef CONFIG_BLOCK
  u8 block;
#endif

#ifdef CONFIG_AIRCON
  u8 aircon;
#endif
}
Number_cap;

gpsDataStruct *gpsData;
u8 was_initialized;

Pers_mem *pers_mem = NULL;

SNode *current_number;

u8 has_mt_call;
u8 has_idle_text;
u8 has_locinfo;
u8 is_locked;
u8 is_blocked;
u8 is_aircon;
u8 is_alarm;
u8 is_alarm_1;
u8 is_alarm_2;
u8 is_alarm_accel;
u8 is_brake_lights;
u8 was_manual_on_delay;
u8 was_manual_off_delay;
u8 was_manual_lock;
u8 alarm_reported;
u8 alarm_reported_btn;
u8 alarm_being_reported;	// sms is being sent, disable duplicates
u8 alarm_panic_reported;
u8 is_val_valid;
b16 vx, vy;
u16 dx, dy;
u8 alarm_x, alarm_y;		// based on sensitivity
u16 cur_time;			// in seconds
u16 manual_lock_time;		// when was man.locked
u16 check_net_time;		// elapsed time since last net check

u16 last_time_net;		// last time not was avail
u16 alarm_time;			// when was alarm
u16 alarm_time_reported;
u8 nr_status;
u8 poll_int;

#ifdef CONFIG_MEASURE
u16 max_dx;
u16 max_dy;
u16 nr_count;
#endif

#define ACCEL_INTERVAL 1
u8 accel_interval;

//------------------------------------------------------------------------
//  ACCELEROMETER VCC from MCU pins PE2,PE3
//------------------------------------------------------------------------

#define ACCEL_VCC0_DDR DDRE
#define ACCEL_VCC0_DDR_PIN DD2
#define ACCEL_VCC0_PORT PORTE
#define ACCEL_VCC0_PORT_PIN PORT2

#define ACCEL_VCC1_DDR DDRE
#define ACCEL_VCC1_DDR_PIN DD3
#define ACCEL_VCC1_PORT PORTE
#define ACCEL_VCC1_PORT_PIN PORT3

#define CONFIG_ACC_TON_DELAY_MILISEC (160)
#define CONFIG_ACC_TOFF_DELAY_MILISEC (5)

u8 accel_is_on;

void init_accel ()
{
  // enable POWER for ACCELEROMETER

  sbi (ACCEL_VCC0_DDR, ACCEL_VCC0_DDR_PIN);	//ACCEL_VCC0 pin is OUTPUT
  asm __volatile__ ("nop");	//wait

  sbi (ACCEL_VCC1_DDR, ACCEL_VCC1_DDR_PIN);	//ACCEL_VCC1 pin is OUTPUT
  asm __volatile__ ("nop");	//wait

  cbi (ACCEL_VCC0_PORT, ACCEL_VCC0_PORT_PIN);	//set ACCEL_VCC0 pin output register bit to log.0
  asm __volatile__ ("nop");	//wait

  cbi (ACCEL_VCC1_PORT, ACCEL_VCC1_PORT_PIN);	//set ACCEL_VCC0 pin output register bit to log.0
  asm __volatile__ ("nop");	//wait

  accel_is_on = 0;
}

void init_variables (void)
{
  gpsData->utcTime[0] = '\0';
  gpsData->latitude[0] = '\0';
  gpsData->latitudeH[0] = '\0';
  gpsData->longitude[0] = '\0';
  gpsData->longitudeH[0] = '\0';
  gpsData->satellites[0] = '\0';
  gpsData->altitude[0] = '\0';
  gpsData->course[0] = '\0';
  gpsData->speed[0] = '\0';
  gpsData->date[0] = '\0';
}

void init_mcuPorts (void)
{
  //I2CMA_SCL
  //change direction  to input
  //set pin to log.1
  //
  cbi (I2CMA_SCL_DDR, I2CMA_SCL_DDR_DD);
  sbi (I2CMA_SCL_PORT, I2CMA_SCL_PORT_PIN);

  //I2CMA_SDA
  //change direction  to input
  //set pin to log.1
  //
  cbi (I2CMA_SDA_DDR, I2CMA_SDA_DDR_DD);
  sbi (I2CMA_SDA_PORT, I2CMA_SDA_PORT_PIN);

  //I2CMA_RXFn
  //change direction  to input
  //set pin to log.1
  //
  cbi (I2CMA_RXFn_DDR, I2CMA_RXFn_DDR_DD);
  sbi (I2CMA_RXFn_PORT, I2CMA_RXFn_PORT_PIN);

  //I2CMA_TXEn
  //change direction  to input
  //set pin to log.1
  //
  cbi (I2CMA_TXEn_DDR, I2CMA_TXEn_DDR_DD);
  sbi (I2CMA_TXEn_PORT, I2CMA_TXEn_PORT_PIN);
}

void init_I2c (void)
{
  init_uart2i2c (MY_SLAVE_ADDRESS);
//    uart2i2c_write_ubrrl (25);
}

void enableParserGps (void)
{
  u8 cntrl;

  uart2i2c_read_control (&cntrl);
  uart2i2c_write_control (cntrl | UART2I2C_STATUS_CONTROL_PARSER_ENABLED);	//enable parser
}

void clearGpsDataGps (void)
{
  u8 cntrl;

  uart2i2c_read_control (&cntrl);
  uart2i2c_write_control (cntrl | UART2I2C_STATUS_CONTROL_CLEAR_GPS_DATA);
}

void actualizePositionGps (void)
{
  u8 *p;
  u8 i;

  p = gpsData;
  if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER_EVO)
    for (i = 0; i < sizeof (gpsDataStruct); i++)
      uart2i2c_read_gps_data (i, &(p[i]));
  else
    for (i = 0; i < sizeof (gpsDataStruct); i++)
      p[i] = 0;

#if 0
  for (i = 0; i < UART2I2C_GPS_UTC_TIME_SIZE - 1; i++)
    gpsData->utcTime[i] = '0' + i;
  gpsData->utcTime[i] = '\0';

  for (i = 0; i < UART2I2C_GPS_LATITUDE_SIZE - 1; i++)
    gpsData->latitude[i] = '0' + i;
  gpsData->latitude[i] = '\0';
  for (i = 0; i < UART2I2C_GPS_LATITUDE_H_SIZE - 1; i++)
    gpsData->latitudeH[i] = '0' + i;
  gpsData->latitudeH[i] = '\0';
  for (i = 0; i < UART2I2C_GPS_LONGITUDE_SIZE - 1; i++)
    gpsData->longitude[i] = '0' + i;
  gpsData->longitude[i] = '\0';
  for (i = 0; i < UART2I2C_GPS_LONGITUDE_H_SIZE - 1; i++)
    gpsData->longitudeH[i] = '0' + i;
  gpsData->longitudeH[i] = '\0';
  for (i = 0; i < UART2I2C_GPS_COURSE_SIZE - 1; i++)
    gpsData->course[i] = '0' + i;
  gpsData->course[i] = '\0';
  for (i = 0; i < UART2I2C_GPS_SPEED_SIZE - 1; i++)
    gpsData->speed[i] = '0' + i;
  gpsData->speed[i] = '\0';
  for (i = 0; i < UART2I2C_GPS_DATE_SIZE - 1; i++)
    gpsData->date[i] = '0' + i;
  gpsData->date[i] = '\0';
#endif

  gpsData->latitude[UART2I2C_GPS_LATITUDE_SIZE - 1] = '\0';
  gpsData->latitudeH[UART2I2C_GPS_LATITUDE_H_SIZE - 1] = '\0';
  gpsData->longitude[UART2I2C_GPS_LONGITUDE_SIZE - 1] = '\0';
  gpsData->longitudeH[UART2I2C_GPS_LONGITUDE_H_SIZE - 1] = '\0';
  gpsData->course[UART2I2C_GPS_COURSE_SIZE - 1] = '\0';
  gpsData->speed[UART2I2C_GPS_SPEED_SIZE - 1] = '\0';
  gpsData->date[UART2I2C_GPS_DATE_SIZE - 1] = '\0';
  gpsData->utcTime[UART2I2C_GPS_UTC_TIME_SIZE - 1] = '\0';
  gpsData->satellites[UART2I2C_GPS_SATELLITES_SIZE - 1] = '\0';
  gpsData->altitude[UART2I2C_GPS_ALTITUDE_SIZE - 1] = '\0';
}

void delay_1ms (void)
{
  u16 i;

  for (i = 0; i < 1000; i++)
  {
    __asm__ __volatile__ ("nop");
    __asm__ __volatile__ ("nop");
  }
}

u8 *start_ucs2 (u8 * r)
{
  if (proc_8 (PROC_8_LANGUAGE) == LC_RUSSIAN)
    r = sprintucs2_start (r, DCS_UCS2);

  return r;
}

u8 *end_ucs2 (u8 * r)
{
  if (proc_8 (PROC_8_LANGUAGE) == LC_RUSSIAN)
    sprintucs2_end ();
  else
    r = sprintc (r, '\0');
  return r;
}

void ton_accel ()
{
  u16 msecs;

  if (accel_is_on == 0)
  {
    // Turn on ACCEL VCC
    sbi (ACCEL_VCC0_PORT, ACCEL_VCC0_PORT_PIN);	//set ACCEL_VCC0 pin output register bit to log.1
    asm __volatile__ ("nop");	//wait

    sbi (ACCEL_VCC1_PORT, ACCEL_VCC1_PORT_PIN);	//set ACCEL_VCC1 pin output register bit to log.1
    asm __volatile__ ("nop");	//wait

    // wait for a while (ACCEL Turn On Time)
    for (msecs = 0; msecs < CONFIG_ACC_TON_DELAY_MILISEC; msecs++)
    {
      delay_1ms ();
    }
    accel_is_on = 1;
  }
}

void toff_accel ()
{
  u16 msecs;

  if (accel_is_on != 0)
  {
    // wait for a while
    for (msecs = 0; msecs < CONFIG_ACC_TOFF_DELAY_MILISEC; msecs++)
      delay_1ms ();

    // Turn offn ACCEL VCC
    cbi (ACCEL_VCC0_PORT, ACCEL_VCC0_PORT_PIN);	//set ACCEL_VCC0 pin output register bit to log.0
    asm __volatile__ ("nop");	//wait

    cbi (ACCEL_VCC1_PORT, ACCEL_VCC1_PORT_PIN);	//set ACCEL_VCC1 pin output register bit to log.0
    asm __volatile__ ("nop");	//wait

    accel_is_on = 0;
  }
}

//------------------------------------------------------------------------
//  ADC input pins ADC0 = PF0, ADC1 = PF1
//------------------------------------------------------------------------
#define ADC0_DDR DDRF
#define ADC0_DDR_PIN DD0
#define ADC0_PORT PORTF
#define ADC0_PORT_PIN PORT0

#define ADC1_DDR DDRF
#define ADC1_DDR_PIN DD1
#define ADC1_PORT PORTF
#define ADC1_PORT_PIN PORT1

#define CONFIG_ADC_CHANNEL_CHANGE_DELAY_MILISEC (1)
#define ADC_REF_VOLT (0x40)

void init_adc ()
{
  // deactivate pull-ups on ADC0 and ADC1 pins

  cbi (ADC0_DDR, ADC0_DDR_PIN);
  cbi (ADC1_DDR, ADC1_DDR_PIN);
  asm __volatile__ ("nop");	//wait

  cbi (ADC0_PORT, ADC0_PORT_PIN);
  cbi (ADC1_PORT, ADC1_PORT_PIN);

  //Set Voltage reference to AVCC with external capacitor
  //Left Ajust Result disable
  outb (ADMUX, ADC_REF_VOLT);
}

// Measure Voltage on pin of A/D MUX
u8 adc_measure (u16 * voltage, u8 channel)
{
  u16 msecs;

  if (channel >= 8)
    return 1;

  // wait for a while
  // keep in mind Mr. Nyquist
  // this delay will influence sampling frequency !
  for (msecs = 0; msecs < CONFIG_ADC_CHANNEL_CHANGE_DELAY_MILISEC; msecs++)
    delay_1ms ();

  //Use Voltage reference as set in init_adc function
  //Select ADC MUX channel
  outb (ADMUX, (ADC_REF_VOLT | channel));

  //Disable high speed ADC mode
  cbi (SFIOR, ADHSM);

  // Enable ADC
  // Start conversion
  // Disable Free running mode
  // ADCclk=Fosc/16
  outb (ADCSR, 0xC4);

  // Wait here when conversion is not completed with data registers updating
  while ((inb (ADCSR) & (1 << ADIF)) == 0);

  //clear ADCIF flag
  sbi (ADCSR, ADIF);

  //store measured voltage    
  *voltage = inw (ADCW);

  // Disable ADC
  outb (ADCSR, 0x00);

  return 0;
}

u8 accel_measure (u16 * voltage, u8 channel)
{
  b16 x;
  u8 s;
  u8 i;

  for (i = 0; i < 20; i++)
    s = adc_measure (&x, channel);
  *voltage = x;
  return s;
}

void accel_flush ()
{
  u8 numOfX;
  u8 numOfSamples;
  u8 jj;
  b16 vx, vy;

  uart2i2c_read_accelx_words (&numOfX);
  uart2i2c_read_accely_words (&numOfSamples);

  dbsp (">accels_measure ");
  dbch (numOfX);
  dbc (' ');
  dbch (numOfSamples);
  dbc ('\n');
  if (numOfSamples > numOfX)
    numOfSamples = numOfX;

  for (jj = 0; jj < numOfSamples; jj++)
  {
    uart2i2c_read_accelx_fifo_data (&vx, 1);
    uart2i2c_read_accely_fifo_data (&vy, 1);
  }
}

u8 accels_measure (u16 * v0, u16 * v1)
{
  if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER)
  {
    dbsp (">accels_measure_old\n");
    ton_accel ();
    accel_measure (v0, 0);
    accel_measure (v1, 1);
    toff_accel ();
    return 0;			//values OK
  }
  else if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER_EVO)
  {
    u16 max_dx_local, max_dy_local;
    u8 numOfX;
    u8 numOfSamples;
    u8 jj;
    b16 val0, val1;
    b16 vx, vy;
    u16 dx, dy;

    dbsp (">accels_measure_new\n");

    do
    {
      uart2i2c_read_accelx_words (&numOfX);
      uart2i2c_read_accely_words (&numOfSamples);

      dbsp (">accels_measure ");
      dbch (numOfX);
      dbc (' ');
      dbch (numOfSamples);
      dbc ('\n');
      if (numOfSamples > numOfX)
	numOfSamples = numOfX;
      if (numOfSamples == 0)
	delayMs (300);
    }
    while (numOfSamples == 0);

    if (numOfSamples > 0)
    {
      max_dx_local = 0;
      max_dy_local = 0;
      for (jj = 0; jj < numOfSamples; jj++)
      {
	uart2i2c_read_accelx_fifo_data (&vx, 1);
	uart2i2c_read_accely_fifo_data (&vy, 1);
	if (jj == 0)
	{
	  val0 = vx;
	  val1 = vy;
//           first = 0;
	}
	dx = abs (vx - val0);
	dy = abs (vy - val1);
	dbih (vx);
	dbc (' ');
	dbih (vy);
	dbc (' ');
	dbih (dx);
	dbc (' ');
	dbih (dy);
	dbc ('\n');
	val0 = vx;
	val1 = vy;
	if (dx > max_dx_local)
	  max_dx_local = dx;
	if (dy > max_dy_local)
	  max_dy_local = dy;
      }
      *v0 = vx;
      *v1 = vy;
      return 0;			//values OK
    }
    else
    {
      *v0 = 0;
      *v1 = 0;
      return 1;			//values NOT VALID
    }
  }
}

u8 accel_new_interval_delay (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    u8 x;
    u8 *t = buf_B ();
    u8 d;

    d = rb (&pers_mem->poll_interval_new);

    res = t;
    res = sprinti (res, d);
    res = sprintc (res, '\0');

    res = get_input (locale (lc_Seconds), 1, 2, t, Q_GET_INPUT_DIGITS);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;
    res[res[0] + 1] = '\0';
    x = atoi (&res[2]);
    accel_interval = x;
//    uart2i2c_write_interval (accel_interval);
    d = x;

    res = t;
    res = sprints (res, locale (lc_Poll_Interval_Set));
    res = sprinti (res, d);
    res = sprints (res, locale (lc_Seconds_2));
    res = sprintc (res, '\0');
    if (display_text (t, NULL) == APP_END)
      return APP_END;
    if (d != rb (&pers_mem->poll_interval_new))
      wb (&pers_mem->poll_interval_new, d);
    return APP_BACK;
  }
  return APP_OK;
}

//!!! ALL ALARM I/O signals are active log.0 for now !!!!
//this will extend battery life
//and it assumes using optocouplers on each signal (both directions)
//MCU output pin log.0 would switch on the input LED of optocoupler(active)
//MCU input pin log.0 means that output phototransistor of optocoupler is saturated
//and thus input LED of optocoupler is switched on (active)

#define CONFIG_CANCEL_ALARM2_DELAY_MILISEC 500

#define LEVEL_LOW 0
#define LEVEL_HIGH 1

#define OUTPUT_ACTIVE_LEVEL LEVEL_LOW
#define INPUT_ACTIVE_LEVEL LEVEL_LOW

#define ALARM_IN_CENTRAL_DDR DDRF
#define ALARM_IN_CENTRAL_DDR_PIN DD2
#define ALARM_IN_CENTRAL_PORT PORTF
#define ALARM_IN_CENTRAL_PORT_PIN PORT2
#define ALARM_IN_CENTRAL_PIN PINF
#define ALARM_IN_CENTRAL_PIN_PIN PIN2

#define ALARM_IN_EVO_CENTRAL_DDR DDRE
#define ALARM_IN_EVO_CENTRAL_DDR_PIN DD6
#define ALARM_IN_EVO_CENTRAL_PORT PORTE
#define ALARM_IN_EVO_CENTRAL_PORT_PIN PORT6
#define ALARM_IN_EVO_CENTRAL_PIN PINE
#define ALARM_IN_EVO_CENTRAL_PIN_PIN PIN6

// ALARM1 - Engine starter ?
#define ALARM_IN_ALARM1_DDR DDRF
#define ALARM_IN_ALARM1_DDR_PIN DD3
#define ALARM_IN_ALARM1_PORT PORTF
#define ALARM_IN_ALARM1_PORT_PIN PORT3
#define ALARM_IN_ALARM1_PIN PINF
#define ALARM_IN_ALARM1_PIN_PIN PIN3

#define ALARM_IN_EVO_ALARM1_DDR DDRE
#define ALARM_IN_EVO_ALARM1_DDR_PIN DD7
#define ALARM_IN_EVO_ALARM1_PORT PORTE
#define ALARM_IN_EVO_ALARM1_PORT_PIN PORT7
#define ALARM_IN_EVO_ALARM1_PIN PINE
#define ALARM_IN_EVO_ALARM1_PIN_PIN PIN7

// ALARM2 - Intruder alarm (output from alarm already installed in the car?)
#define ALARM_IN_ALARM2_DDR DDRF
#define ALARM_IN_ALARM2_DDR_PIN DD5
#define ALARM_IN_ALARM2_PORT PORTF
#define ALARM_IN_ALARM2_PORT_PIN PORT5
#define ALARM_IN_ALARM2_PIN PINF
#define ALARM_IN_ALARM2_PIN_PIN PIN5

// AIRCON - Aircondition ? 
#define ALARM_IN_AIRCON_DDR DDRF
#define ALARM_IN_AIRCON_DDR_PIN DD6
#define ALARM_IN_AIRCON_PORT PORTF
#define ALARM_IN_AIRCON_PORT_PIN PORT6
#define ALARM_IN_AIRCON_PIN PINF
#define ALARM_IN_AIRCON_PIN_PIN PIN6

// was IN_USER
#define ALARM_IN_PANIC_DDR DDRG
#define ALARM_IN_PANIC_DDR_PIN DD1
#define ALARM_IN_PANIC_PORT PORTG
#define ALARM_IN_PANIC_PORT_PIN PORT1
#define ALARM_IN_PANIC_PIN PING
#define ALARM_IN_PANIC_PIN_PIN PIN1

#define ALARM_OUT_BLOCK_DDR DDRA
#define ALARM_OUT_BLOCK_DDR_PIN DD4
#define ALARM_OUT_BLOCK_PORT PORTA
#define ALARM_OUT_BLOCK_PORT_PIN PORT4

#define ALARM_OUT_EVO_BLOCK_DDR DDRE
#define ALARM_OUT_EVO_BLOCK_DDR_PIN DD2
#define ALARM_OUT_EVO_BLOCK_PORT PORTE
#define ALARM_OUT_EVO_BLOCK_PORT_PIN PORT2

#define ALARM_OUT_CANCEL_ALARM2_DDR DDRA
#define ALARM_OUT_CANCEL_ALARM2_DDR_PIN DD7
#define ALARM_OUT_CANCEL_ALARM2_PORT PORTA
#define ALARM_OUT_CANCEL_ALARM2_PORT_PIN PORT7

// was OUT_USER3
#define ALARM_OUT_ALARM_DDR DDRC
#define ALARM_OUT_ALARM_DDR_PIN DD6
#define ALARM_OUT_ALARM_PORT PORTC
#define ALARM_OUT_ALARM_PORT_PIN PORT6

// was OUT_USER1
#define ALARM_OUT_ALARM_BTN_DDR DDRC
#define ALARM_OUT_ALARM_BTN_DDR_PIN DD2
#define ALARM_OUT_ALARM_BTN_PORT PORTC
#define ALARM_OUT_ALARM_BTN_PORT_PIN PORT2

// was OUT_USER2
#define ALARM_OUT_ACTIVE_DDR DDRC
#define ALARM_OUT_ACTIVE_DDR_PIN DD1
#define ALARM_OUT_ACTIVE_PORT PORTC
#define ALARM_OUT_ACTIVE_PORT_PIN PORT1

//was OUT_USER4
#define ALARM_OUT_CHARGER_DDR DDRC
#define ALARM_OUT_CHARGER_DDR_PIN DD4
#define ALARM_OUT_CHARGER_PORT PORTC
#define ALARM_OUT_CHARGER_PORT_PIN PORT4

#define ALARM_OUT_AIRCON_DDR DDRC
#define ALARM_OUT_AIRCON_DDR_PIN DD7
#define ALARM_OUT_AIRCON_PORT PORTC
#define ALARM_OUT_AIRCON_PORT_PIN PORT7

#define ALARM_OUT_EVO_AIRCON_DDR DDRE
#define ALARM_OUT_EVO_AIRCON_DDR_PIN DD3
#define ALARM_OUT_EVO_AIRCON_PORT PORTE
#define ALARM_OUT_EVO_AIRCON_PORT_PIN PORT3

#define ALARM_OUT_BRAKE_DDR DDRA
#define ALARM_OUT_BRAKE_DDR_PIN DD6
#define ALARM_OUT_BRAKE_PORT PORTA
#define ALARM_OUT_BRAKE_PORT_PIN PORT6

void init_alarm_pins ()
{

  if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER)
  {
    cbi (ALARM_IN_CENTRAL_DDR, ALARM_IN_CENTRAL_DDR_PIN);	//ALARM_IN_CENTRAL pin is INPUT
    asm __volatile__ ("nop");	//wait

    sbi (ALARM_IN_CENTRAL_PORT, ALARM_IN_CENTRAL_PORT_PIN);	//set ALARM_IN_CENTRAL pin output register bit to log.1
    asm __volatile__ ("nop");	//wait

    cbi (ALARM_IN_ALARM1_DDR, ALARM_IN_ALARM1_DDR_PIN);	//ALARM_IN_ALARM1 pin is INPUT
    asm __volatile__ ("nop");	//wait

    sbi (ALARM_IN_ALARM1_PORT, ALARM_IN_ALARM1_PORT_PIN);	//set ALARM_IN_ALARM1 pin output register bit to log.1
    asm __volatile__ ("nop");	//wait

    sbi (ALARM_OUT_AIRCON_DDR, ALARM_OUT_AIRCON_DDR_PIN);	//ALARM_OUT_AIRCON pin is OUTPUT
    asm __volatile__ ("nop");	//wait

    sbi (ALARM_OUT_AIRCON_PORT, ALARM_OUT_AIRCON_PORT_PIN);	//set ALARM_OUT_AIRCON pin output register bit to log.1(active log.0)
    asm __volatile__ ("nop");	//wait

    sbi (ALARM_OUT_BLOCK_DDR, ALARM_OUT_BLOCK_DDR_PIN);	//ALARM_OUT_BLOCK pin is OUTPUT
    asm __volatile__ ("nop");	//wait

    sbi (ALARM_OUT_BLOCK_PORT, ALARM_OUT_BLOCK_PORT_PIN);	//set ALARM_OUT_BLOCK pin output register bit to log.1(active log.0)
    asm __volatile__ ("nop");	//wait
  }
  else if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER_EVO)
  {
    cbi (ALARM_IN_EVO_CENTRAL_DDR, ALARM_IN_EVO_CENTRAL_DDR_PIN);	//ALARM_IN_EVO_CENTRAL pin is INPUT
    asm __volatile__ ("nop");	//wait

    sbi (ALARM_IN_EVO_CENTRAL_PORT, ALARM_IN_EVO_CENTRAL_PORT_PIN);	//set ALARM_IN_EVO_CENTRAL pin output register bit to log.1
    asm __volatile__ ("nop");	//wait

    cbi (ALARM_IN_EVO_ALARM1_DDR, ALARM_IN_EVO_ALARM1_DDR_PIN);	//ALARM_IN_EVO_ALARM1 pin is INPUT
    asm __volatile__ ("nop");	//wait

    sbi (ALARM_IN_EVO_ALARM1_PORT, ALARM_IN_EVO_ALARM1_PORT_PIN);	//set ALARM_IN_EVO_ALARM1 pin output register bit to log.1
    asm __volatile__ ("nop");	//wait

#ifdef CONFIG_OPTO_OUT_1_PULSE
// OPTO_OUT_1 is alarm pulse and P11 is OUT_AIRCON
    sbi (ALARM_OUT_AIRCON_DDR, ALARM_OUT_AIRCON_DDR_PIN);	//ALARM_OUT_AIRCON pin is OUTPUT
    asm __volatile__ ("nop");	//wait

    sbi (ALARM_OUT_AIRCON_PORT, ALARM_OUT_AIRCON_PORT_PIN);	//set ALARM_OUT_AIRCON pin output register bit to log.1(active log.0)
    asm __volatile__ ("nop");	//wait
#endif

    sbi (ALARM_OUT_EVO_AIRCON_DDR, ALARM_OUT_EVO_AIRCON_DDR_PIN);	//ALARM_OUT_EVO_AIRCON pin is OUTPUT
    asm __volatile__ ("nop");	//wait

    sbi (ALARM_OUT_EVO_AIRCON_PORT, ALARM_OUT_EVO_AIRCON_PORT_PIN);	//set ALARM_OUT_EVO_AIRCON pin output register bit to log.1(active log.0)
    asm __volatile__ ("nop");	//wait

    sbi (ALARM_OUT_EVO_BLOCK_DDR, ALARM_OUT_EVO_BLOCK_DDR_PIN);	//ALARM_OUT_EVO_BLOCK pin is OUTPUT
    asm __volatile__ ("nop");	//wait

    sbi (ALARM_OUT_EVO_BLOCK_PORT, ALARM_OUT_EVO_BLOCK_PORT_PIN);	//set ALARM_OUT_EVO_BLOCK pin output register bit to log.1(active log.0)
    asm __volatile__ ("nop");	//wait
  }

  cbi (ALARM_IN_ALARM2_DDR, ALARM_IN_ALARM2_DDR_PIN);	//ALARM_IN_ALARM2 pin is INPUT
  asm __volatile__ ("nop");	//wait

  sbi (ALARM_IN_ALARM2_PORT, ALARM_IN_ALARM2_PORT_PIN);	//set ALARM_IN_ALARM2 pin output register bit to log.1
  asm __volatile__ ("nop");	//wait

  cbi (ALARM_IN_PANIC_DDR, ALARM_IN_PANIC_DDR_PIN);	//ALARM_IN_PANIC pin is INPUT
  asm __volatile__ ("nop");	//wait

  sbi (ALARM_IN_PANIC_PORT, ALARM_IN_PANIC_PORT_PIN);	//set ALARM_IN_PANIC pin output register bit to log.1
  asm __volatile__ ("nop");	//wait

  sbi (ALARM_OUT_CANCEL_ALARM2_DDR, ALARM_OUT_CANCEL_ALARM2_DDR_PIN);	//ALARM_OUT_CANCEL_ALARM2 pin is OUTPUT
  asm __volatile__ ("nop");	//wait

  sbi (ALARM_OUT_CANCEL_ALARM2_PORT, ALARM_OUT_CANCEL_ALARM2_PORT_PIN);	//set ALARM_OUT_CANCEL_ALARM2_ pin output register bit to log.1(active log.0)
  asm __volatile__ ("nop");	//wait

  cbi (ALARM_IN_AIRCON_DDR, ALARM_IN_AIRCON_DDR_PIN);	//ALARM_IN_AIRCON pin is INPUT
  asm __volatile__ ("nop");	//wait

  sbi (ALARM_IN_AIRCON_PORT, ALARM_IN_AIRCON_PORT_PIN);	//set ALARM_IN_AIRCON pin output register bit to log.1
  asm __volatile__ ("nop");	//wait

  sbi (ALARM_OUT_BRAKE_DDR, ALARM_OUT_BRAKE_DDR_PIN);	//ALARM_OUT_BRAKE pin is OUTPUT
  asm __volatile__ ("nop");	//wait

  sbi (ALARM_OUT_BRAKE_PORT, ALARM_OUT_BRAKE_PORT_PIN);	//set ALARM_OUT_BRAKE pin output register bit to log.1(active log.0)
  asm __volatile__ ("nop");	//wait

  sbi (ALARM_OUT_ALARM_BTN_DDR, ALARM_OUT_ALARM_BTN_DDR_PIN);	//ALARM_OUT_ALARM_BTN pin is OUTPUT
  asm __volatile__ ("nop");	//wait

  sbi (ALARM_OUT_ALARM_BTN_PORT, ALARM_OUT_ALARM_BTN_PORT_PIN);	//set ALARM_OUT_ALARM_BTN_ pin output register bit to log.1(active log.0)
  asm __volatile__ ("nop");	//wait

  sbi (ALARM_OUT_ACTIVE_DDR, ALARM_OUT_ACTIVE_DDR_PIN);	//ALARM_OUT_ACTIVE pin is OUTPUT
  asm __volatile__ ("nop");	//wait

  sbi (ALARM_OUT_ACTIVE_PORT, ALARM_OUT_ACTIVE_PORT_PIN);	//set ALARM_OUT_ACTIVE pin output register bit to log.1(active log.0)
  asm __volatile__ ("nop");	//wait

  sbi (ALARM_OUT_ALARM_DDR, ALARM_OUT_ALARM_DDR_PIN);	//ALARM_OUT_ALARM pin is OUTPUT
  asm __volatile__ ("nop");	//wait

  sbi (ALARM_OUT_ALARM_PORT, ALARM_OUT_ALARM_PORT_PIN);	//set ALARM_OUT_ALARM pin output register bit to log.1(active log.0)
  asm __volatile__ ("nop");	//wait

  sbi (ALARM_OUT_CHARGER_DDR, ALARM_OUT_CHARGER_DDR_PIN);	//ALARM_OUT_CHARGER pin is OUTPUT
  asm __volatile__ ("nop");	//wait

  cbi (ALARM_OUT_CHARGER_PORT, ALARM_OUT_CHARGER_PORT_PIN);	//set ALARM_OUT_CHARGER pin output register bit to log.1(active log.0)
  asm __volatile__ ("nop");	//wait

}

void preset_alarm_outputs ()
{
//default values of outputs from init_alarm_pins() function
//can be changed here to others
//init_alarm_pins() function sets all outputs to log.1(not active, active = log.0)
//any change is not necessary for now, all outputs are inactive from init_alarm_pins()
}

void reset_vals ()		//init, unlocked, no alarm
{
  was_manual_on_delay = 0;
  was_manual_off_delay = 0;
  is_locked = 0;
  is_alarm = 0;
  is_alarm_1 = 0;
  is_alarm_2 = 0;
  is_alarm_accel = 0;
  is_val_valid = 0;
  was_manual_lock = 0;
  alarm_reported = 0;
  alarm_reported_btn = 0;
  alarm_being_reported = 0;

  if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER_EVO)
    uart2i2c_write_interval (0);
}

b8 my_poll_interval (u8 d)
{
  u8 *res;
  u8 j;

  dbsp ("MY_POLL_INT\n");

  poll_int = 30;
  res = poll_interval (DURATION_SEC, d);
  j = get_tag (res, T_RESULT);
  if (j == 0)
    return -1;
  j++;				// tag
  j++;				// len
  if (res[j] != 0x00)
  {
    dbsp ("SET POLL INTERVAL ERROR\n");
    return -1;
  }

  j = get_tag (res, T_DURATION);
  if (j == 0)
    return -1;
  j++;				// tag
  j++;				// len
  dbsp ("POLL INT UNITS ");
  dbch (res[j]);
  dbc ('\n');
  j++;				// units
  dbsp ("POLL INT ");
  dbch (res[j]);
  dbc ('\n');
  poll_int = res[j];
  return res[j];
}

void set_idle_text ()
{
  u8 len = 0;
  u8 *buf = buf_A ();
  u8 *text;
  u8 i;

  if (has_idle_text == 0)
    return;

  if (is_locked)
    text = locale (lc_Alarm_Locked);
  else
    text = locale (lc_Alarm_Unlocked);

  len = strlen (text);

  buf[0] = T_TEXT_STRING | CR_FLAG;

  if (rb (text) == STRING_SLV)
  {
    buf[2] = rb (text + 1);
    text += 4;
    len--;
  }
  else
    buf[2] = 0x04;

  buf[1] = len + 1;

  memcpy (&buf[3], text, len);
  len += 3;

  stk_cmd (STK_CMD_SET_UP_IDLE_MODE_TEXT, 0x00, DEV_ID_ME, len);
}

void set_menu ()
{
  if (is_locked)
  {
    insert_menu (locale (lc_Alarm_Unlock));
  }
  else
  {
    insert_menu (locale (lc_Alarm_Lock));
    insert_menu (locale (lc_Numbers));
    insert_menu (locale (lc_Alarm_Config));
  }
}

void set_active_on ();
void set_active_off ();

void setmenu (void *data)
{
  set_up_menu ();
  if (is_locked)
  {
    set_active_on ();
    my_poll_interval (rb (&pers_mem->poll_interval));
  }
  else
  {
    set_alarm_off ();
    set_active_off ();
  }
  set_idle_text ();
}

void setpoll (void *data)
{
  my_poll_interval (rb (&pers_mem->poll_interval));
  set_idle_text ();
}

u8 yesno_val (u8 * ret, u8 val, u8 * text, u8 * help)
{
  u8 *res;
  u8 j;
  u8 *t_list[3];

#define ITEM_LEN	20
  u8 *t_items;

X_START:
  t_items = malloc (3 * ITEM_LEN);
  if (t_items == NULL)
    return perror (ERR_NO_RAM);

  t_list[0] = &t_items[0];
  t_list[1] = &t_items[ITEM_LEN];
  t_list[2] = &t_items[2 * ITEM_LEN];

  res = t_list[0];
  res = start_ucs2 (res);
  if (val == 1)
    res = sprintc (res, '*');
  else
    res = sprintc (res, ' ');
  res = sprintc (res, ' ');
  res = sprints (res, locale (lc_SMS_Yes));
  res = end_ucs2 (res);

  res = t_list[1];
  res = start_ucs2 (res);
  if (val != 1)
    res = sprintc (res, '*');
  else
    res = sprintc (res, ' ');
  res = sprintc (res, ' ');
  res = sprints (res, locale (lc_SMS_No));
  res = end_ucs2 (res);

//  memcpy (t_list[0], locale (lc_Yes), strlen (locale (lc_Yes)) + 1);
//  memcpy (t_list[1], locale (lc_No), strlen (locale (lc_No)) + 1);

  if (help)
  {
    res = t_list[2];
    res = start_ucs2 (res);
    res = sprints (res, locale (lc_Help));
    res = end_ucs2 (res);
  }

/*
    memcpy (t_list[2], locale (lc_Help), strlen (locale (lc_Help)) + 1);

  if (val == 1)
  {
    t_list[0][0] = '*';
  }
  else
  {
    t_list[1][0] = '*';
  }
*/

  j = 1;
  if (val == 0)
    j = 2;

  if (help)
    res = select_item (3, t_list, text, NULL, j, Q_SELECT_ITEM_CHOICE);
  else
    res = select_item (2, t_list, text, NULL, j, Q_SELECT_ITEM_CHOICE);
  free (t_items);

  j = get_tag (res, T_RESULT);
  if (j != 0)
  {
    j++;			// tag
    j++;			//len
    if (res[j] == 0x10)
      return APP_END;		// end
    if (res[j] == 0x11 || res[j] == 0x12)
      return APP_BACK;		// back
  }
  j = get_tag (res, T_ITEM_ID);
  if (j != 0)
  {
    j++;			//tag
    j++;			//len
    if (res[j] == 1)
      *ret = 1;
    else if (res[j] == 2)
      *ret = 0;
    else			//help
    {
      if (display_text (help, NULL) == APP_END)
	return APP_END;
      goto X_START;
    }
  }
  return APP_OK;
}

extern SNodeP alarm_n_lock;
extern SNodeP alarm_n_unlock;
extern SEdgeP alarm_edges_p[];

u8 alarm_numbers (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    ctx->eE = rw (&pers_mem->numbers);
  }
  else if (action == APP_LEAVE)
  {
    ctx->eE = NULL;
  }
  return APP_OK;
}

extern SNodeP alarm_number_aircon_n;
extern SNodeP alarm_number_block_n;
extern SNodeP alarm_number_call_confirm_n;
extern SNodeP alarm_number_call_onoff_n;
extern SNodeP alarm_number_sms_onoff_n;
extern SNodeP alarm_number_fax_sms_ctx_n;
extern SNodeP alarm_number_status_n;
extern SNodeP alarm_number_call_alarm_n;
extern SNodeP alarm_number_send_turbo_sms_alarm_n;
extern SNodeP alarm_number_send_alarm_n;
extern SNodeP alarm_number_delete_n;
extern SNodeP alarm_number_view_n;

u8 alarm_pin_prot (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    u8 *res_1;
    u8 val = rb (&pers_mem->is_pin);

    res = yesno_val (&ret, val, locale (lc_Protect_PIN), NULL);
    if (res != APP_OK)
      return res;
    if (ret == 1)
    {
      u8 *t = buf_B ();
      u8 i;

      res_1 = t;
      for (i = 0; i < 4; i++)
	res_1 = sprintc (res_1, rb (&pers_mem->pin[i]));
      res_1 = sprintc (res_1, '\0');

      res_1 = get_input (locale (lc_Enter_PIN), 4, 4, t, Q_GET_INPUT_DIGITS);
      if (res_1 == ENULL)
	return APP_END;
      if (res_1 == NULL)
	return APP_BACK;
      for (i = 0; i < 4; i++)
	wb (&pers_mem->pin[i], res_1[2 + i]);
    }

    if (ret != val)
    {
      wb (&pers_mem->is_pin, ret);
    }
    return APP_BACK;
  }
  return APP_OK;
}

#ifdef CONFIG_AIRCON
u8 alarm_number_aircon (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = current_number;
    u8 *text = locale (rw (&n->text));
    Number_cap *nc = rw (&np->p);
    u8 val = rb (&nc->aircon);

    res = yesno_val (&ret, val, text, NULL);
    if (res != APP_OK)
      return res;
    if (ret != val)
      wb (&nc->aircon, ret);
    return APP_BACK;
  }
  return APP_OK;
}
#endif

u8 alarm_alarm_1 (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = current_number;
    u8 *text = locale (rw (&n->text));
    Number_cap *nc = rw (&np->p);
    u8 val = rb (&pers_mem->alarm_1);

    res = yesno_val (&ret, val, text, NULL);
    if (res != APP_OK)
      return res;
    if (ret != val)
      wb (&pers_mem->alarm_1, ret);
    return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_alarm_2 (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = current_number;
    u8 *text = locale (rw (&n->text));
    Number_cap *nc = rw (&np->p);
    u8 val = rb (&pers_mem->alarm_2);

    res = yesno_val (&ret, val, text, NULL);
    if (res != APP_OK)
      return res;
    if (ret != val)
      wb (&pers_mem->alarm_2, ret);
    return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_central_lock (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = current_number;
    u8 *text = locale (rw (&n->text));
    Number_cap *nc = rw (&np->p);
    u8 val = rb (&pers_mem->central_lock);

    res = yesno_val (&ret, val, text, NULL);
    if (res != APP_OK)
      return res;
    if (ret != val)
      wb (&pers_mem->central_lock, ret);
    return APP_BACK;
  }
  return APP_OK;
}

#ifdef CONFIG_BLOCK
u8 alarm_number_block (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = current_number;
    u8 *text = locale (rw (&n->text));
    Number_cap *nc = rw (&np->p);
    u8 val = rb (&nc->block);

    res = yesno_val (&ret, val, text, NULL);
    if (res != APP_OK)
      return res;
    if (ret != val)
      wb (&nc->block, ret);
    return APP_BACK;

  }
  return APP_OK;
}
#endif

u8 PROGMEM t_dXY[] = "X/Y: ";
u8 PROGMEM t_dXY_max[] = "dX/dY: ";

#ifdef CONFIG_MEASURE
u8 PROGMEM t_X_max[] = "XMAX: ";
u8 PROGMEM t_Y_max[] = "YMAX: ";

u8 PROGMEM t_XB_max[] = "XBMAX: ";
u8 PROGMEM t_XB_min[] = "XBMIN: ";
u8 PROGMEM t_YB_max[] = "YBMAX: ";
u8 PROGMEM t_YB_min[] = "YBMIN: ";

u8 PROGMEM t_X[] = "X: ";
u8 PROGMEM t_Y[] = "Y: ";
u8 PROGMEM t_dXY_max1[] = "mdX/mdY: ";
#endif

u8 alarm_show_gps (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *t = buf_B ();
    u8 *r;
    u8 i;
    u8 tmpVal;
    u8 s;

  X1:
    r = t;

//    clearGpsDataGps ();
    actualizePositionGps ();

    r = sprints (r, t_gpsData_UTC);
    r = sprints (r, gpsData->utcTime);
    r = sprintc (r, '\n');

    r = sprints (r, t_gpsData_LATITUDE);
    r = sprints (r, gpsData->latitude);
    r = sprints (r, gpsData->latitudeH);
    r = sprintc (r, '\n');

    r = sprints (r, t_gpsData_LONGITUDE);
    r = sprints (r, gpsData->longitude);
    r = sprints (r, gpsData->longitudeH);
    r = sprintc (r, '\n');

    r = sprints (r, t_gpsData_SATELLITES);
    r = sprints (r, gpsData->satellites);
    r = sprintc (r, '\n');

    r = sprints (r, t_gpsData_DATE);
    r = sprints (r, gpsData->date);
    r = sprintc (r, '\n');

    r = sprints (r, t_gpsData_ALTITUDE);
    r = sprints (r, gpsData->altitude);
    r = sprintc (r, '\n');

    r = sprints (r, t_gpsData_COURSE);
    r = sprints (r, gpsData->course);
    r = sprintc (r, '\n');

    r = sprints (r, t_gpsData_SPEED);
    r = sprints (r, gpsData->speed);
    r = sprintc (r, '\n');

    r = sprintc (r, '\0');

    r = display_text_raw (t, Q_DISPLAY_TEXT_DELAY_CLEAR);
    s = get_tag (r, T_RESULT);
    if (s != 0)
    {
      s++;
      s++;
      if (r[s] == 0x10)
	return APP_END;		//end
      if (r[s] == 0x11)
	return APP_BACK;	//back
      goto X1;
    }

    return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_init_gps (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    clearGpsDataGps ();
    return APP_BACK;
  }
  return APP_OK;
}

#ifdef CONFIG_LANG_EN
u8 PROGMEM t_br4800_en[] = "4800";
u8 PROGMEM t_br9600_en[] = "9600";
u8 PROGMEM t_br19200_en[] = "19200";
u8 PROGMEM t_br38400_en[] = "38400";

const u8 *PROGMEM l_baudrates_en[] = {
  t_br4800_en,
  t_br9600_en,
  t_br19200_en,
  t_br38400_en
};
#endif

/* *INDENT-OFF* */
lc_list PROGMEM lc_Baudrates[]={
        LC_EN_LIST(l_baudrates_en)
        LC_END_LIST
};
/* *INDENT-ON* */

u8 PROGMEM t_intoff_en[] = "OFF";
u8 PROGMEM t_int1_en[] = "1s";
u8 PROGMEM t_int2_en[] = "2s";
u8 PROGMEM t_int5_en[] = "5s";
u8 PROGMEM t_int10_en[] = "10s";

const u8 *PROGMEM l_NmeaIntervals_en[] = {
  t_intoff_en,
  t_int1_en,
  t_int2_en,
  t_int5_en,
  t_int10_en
};

/* *INDENT-OFF* */
lc_list PROGMEM lc_NmeaIntervals[]={
        LC_EN_LIST(l_NmeaIntervals_en)
        LC_END_LIST
};
/* *INDENT-ON* */

u8 alarm_set_gps (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    u8 j;

    res =
      select_item (4, locale_list (lc_Baudrates), locale (lc_Baudrate), NULL,
		   rb (&pers_mem->baudrate), Q_SELECT_ITEM_CHOICE);

    j = get_tag (res, T_RESULT);
    if (j != 0)
    {
      j++;			// tag
      j++;			//len
      if (res[j] == 0x10)
	return APP_END;		// end
      if (res[j] == 0x11 || res[j] == 0x12)
	return APP_BACK;	// back
    }
    j = get_tag (res, T_ITEM_ID);
    if (j != 0)
    {
      j++;			//tag
      j++;			//len
      if (res[j] != rb (&pers_mem->baudrate))
      {
	wb (&pers_mem->baudrate, res[j]);
	if (res[j] == 1)
	{
//4800
	  uart2i2c_write_ubrr (103);
	}
	else if (res[j] == 2)
	{
//9600
	  uart2i2c_write_ubrr (51);
	}
	else if (res[j] == 3)
	{
//19200
	  uart2i2c_write_ubrr (25);
	}
	else
	{
//38400
	  uart2i2c_write_ubrr (12);
	}
      }
    }
    return APP_BACK;
  }
  return APP_OK;
}

#if 0
u8 alarm_set_gps_interval_nmea (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    u8 j;

    res =
      select_item (5, locale_list (lc_NmeaIntervals),
		   locale (lc_NmeaInterval), NULL,
		   rb (&pers_mem->interval_nmea), Q_SELECT_ITEM_CHOICE);

    j = get_tag (res, T_RESULT);
    if (j != 0)
    {
      j++;			// tag
      j++;			//len
      if (res[j] == 0x10)
	return APP_END;		// end
      if (res[j] == 0x11 || res[j] == 0x12)
	return APP_BACK;	// back
    }
    j = get_tag (res, T_ITEM_ID);
    if (j != 0)
    {
      j++;			//tag
      j++;			//len
      if (res[j] != rb (&pers_mem->interval_nmea))
      {
	wb (&pers_mem->interval_nmea, res[j]);
	if (res[j] == 1)
	{
//OFF
	  uart2i2c_write_txfifo_data ("@OI 0\n\r", 7);
	}
	else if (res[j] == 2)
	{
//1s
	  uart2i2c_write_txfifo_data ("@OI 1\n\r", 7);
	}
	else if (res[j] == 3)
	{
//2s
	  uart2i2c_write_txfifo_data ("@OI 2\n\r", 7);
	}
	else if (res[j] == 4)
	{
//5s
	  uart2i2c_write_txfifo_data ("@OI 5\n\r", 7);
	}
	else
	{
//10s
	  uart2i2c_write_txfifo_data ("@OI 10\n\r", 8);
	}
      }
    }
    return APP_BACK;
  }
  return APP_OK;
}
#endif

#if 0
u8 PROGMEM t_reading[] = "Reading";
u8 PROGMEM t_UBRRL[] = "UBRRL=";
u8 PROGMEM t_UBRRH[] = "UBRRH=";
u8 PROGMEM t_UCSR[] = "UCSR=";
u8 PROGMEM t_CONTROL[] = "CONTROL=";
u8 PROGMEM t_RXCHARS[] = "RXCHARS=";
u8 PROGMEM t_TXCHARS[] = "TXCHARS=";
u8 PROGMEM t_ID[] = "ID=";

u8 display_text_x (u8 * text)
{
  u8 ret = display_text (text, NULL);

  if (ret == APP_END)
    return APP_END;
  return APP_BACK;
}

u8 alarm_read_gps (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *t = buf_B ();
    u8 *r;
    u8 i;
    u8 tmpVal;
    u8 Gps[16];
    u8 buf[16];

    r = t;
    r = sprints (r, t_reading);
    r = sprintc (r, '\n');

//    uart2i2c_read_rxfifo_status (&(Gps[2]));
//    uart2i2c_read_txfifo_status (&(Gps[3]));
//    uart2i2c_read_rxfifo_cmd (&(Gps[4]));
//    uart2i2c_read_txfifo_cmd (&(Gps[5]));
    uart2i2c_read_ubrr (&(Gps[6]));
    uart2i2c_read_ucsr (&(Gps[8]));
    uart2i2c_read_control (&(Gps[9]));
    uart2i2c_read_rxchars (&(Gps[10]));
    uart2i2c_read_txchars (&(Gps[12]));
    uart2i2c_read_id (&tmpVal);

/*
    r = sprints (r, t_RS);
    r = sprints (r, "0x");
    r = sprintch (r, Gps[2]);
    r = sprintc (r, '\n');
    r = sprints (r, t_TS);
    r = sprints (r, "0x");
    r = sprintch (r, Gps[3]);
    r = sprintc (r, '\n');
    r = sprints (r, t_RC);
    r = sprints (r, "0x");
    r = sprintch (r, Gps[4]);
    r = sprintc (r, '\n');
    r = sprints (r, t_TC);
    r = sprints (r, "0x");
    r = sprintch (r, Gps[5]);
    r = sprintc (r, '\n');
*/

    r = sprints (r, t_UBRRL);
    r = sprints (r, "0x");
    r = sprintch (r, Gps[6]);
    r = sprintc (r, '\n');
    r = sprints (r, t_UBRRH);
    r = sprints (r, "0x");
    r = sprintch (r, Gps[7]);
    r = sprintc (r, '\n');
    r = sprints (r, t_UCSR);
    r = sprints (r, "0x");
    r = sprintch (r, Gps[8]);
    r = sprintc (r, '\n');
    r = sprints (r, t_CONTROL);
    r = sprints (r, "0x");
    r = sprintch (r, Gps[9]);
    r = sprintc (r, '\n');
    r = sprints (r, t_RXCHARS);
    r = sprints (r, "0x");
    r = sprintch (r, Gps[11]);
    r = sprintch (r, Gps[10]);
    r = sprintc (r, '\n');
    r = sprints (r, t_TXCHARS);
    r = sprints (r, "0x");
    r = sprintch (r, Gps[13]);
    r = sprintch (r, Gps[12]);
    r = sprintc (r, '\n');
    r = sprints (r, t_ID);
    r = sprints (r, "0x");
    r = sprintch (r, tmpVal);
    r = sprintc (r, '\n');

    r = sprintc (r, '\0');
    display_text_x (t);
//    r = display_text_raw (t, Q_DISPLAY_TEXT_DELAY_CLEAR);
  }
  return APP_OK;
}
#endif

u8 PROGMEM t_no_value[] = "NO VALUE\n";

u8 alarm_measure_show (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *buf = buf_B ();
    u8 *r = buf;
    u16 i;
    u8 s;
    b16 v0, v1;
    u16 d0, d1;
    b16 val0, val1;
    u16 dx, dy;
    u8 first = 1;
    u8 valid;

    if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER_EVO)
    {
      accel_flush ();
      uart2i2c_write_interval (accel_interval);
    }

  X1:

    valid = accels_measure (&v0, &v1);
    if (valid == 0)
    {

      if (first)
      {
	val0 = v0;
	val1 = v1;
	first = 0;
      }

      dx = d0 = abs (v0 - val0);
      dy = d1 = abs (v1 - val1);
      val0 = v0;
      val1 = v1;

      r = buf;

#ifdef CONFIG_MEASURE
      r = sprints (r, t_dXY_max1);
      r = sprinti (r, max_dx);
      r = sprintc (r, '/');
      r = sprinti (r, max_dy);
      r = sprintc (r, '\n');
#endif

      r = sprints (r, t_dXY);
      r = sprinti (r, val0);
      r = sprintc (r, '/');
      r = sprinti (r, val1);
      r = sprintc (r, '\n');

      r = sprints (r, t_dXY_max);
      r = sprinti (r, dx);
      r = sprintc (r, '/');
      r = sprinti (r, dy);
      r = sprintc (r, '\n');
    }
    else
    {
      r = sprints (r, t_no_value);
    }

    r = sprintc (r, '\0');
    r = display_text_raw (buf, Q_DISPLAY_TEXT_DELAY_CLEAR);
    s = get_tag (r, T_RESULT);
    if (s != 0)
    {
      s++;
      s++;
      if (r[s] == 0x10)
      {
	if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER_EVO)
	{
	  uart2i2c_write_interval (0);
	}
	return APP_END;		//end
      }
      if (r[s] == 0x11)
      {
	if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER_EVO)
	  uart2i2c_write_interval (0);

	return APP_BACK;	//back
      }
      goto X1;
    }

    if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER_EVO)
      uart2i2c_write_interval (0);

    return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_measure_help (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    if (display_text (locale (lc_Measure_Help), NULL) == APP_END)
      return APP_END;
    return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_number_call_confirm (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = current_number;
    u8 *text = locale (rw (&n->text));
    Number_cap *nc = rw (&np->p);
    u8 val = rb (&nc->call_confirm);

    res = yesno_val (&ret, val, text, NULL);
    if (res != APP_OK)
      return res;
    if (ret != val)
      wb (&nc->call_confirm, ret);
    return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_number_call_onoff (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = current_number;
    u8 *text = locale (rw (&n->text));
    Number_cap *nc = rw (&np->p);
    u8 val = rb (&nc->call);

    res = yesno_val (&ret, val, text, NULL);
    if (res != APP_OK)
      return res;
    if (ret != val)
      wb (&nc->call, ret);
    return APP_BACK;
  }
  return APP_OK;
}

extern SNodeP alarm_number_fax_sms_n;
extern SNodeP alarm_number_fax_sms_help_n;

u8 alarm_number_fax_sms_ctx (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    spider_append_r (ctx, &alarm_number_fax_sms_help_n);
    spider_append_r (ctx, &alarm_number_fax_sms_n);
  }
  else if (action == APP_LEAVE)
  {
    spider_clear_r (ctx);
  }
  return APP_OK;
}

u8 alarm_number_sms_onoff (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = current_number;
    u8 *text = locale (rw (&n->text));
    Number_cap *nc = rw (&np->p);
    u8 val = rb (&nc->sms);

    res = yesno_val (&ret, val, text, locale (lc_Number_SMS_Onoff_Help));
    if (res != APP_OK)
      return res;
    if (ret != val)
      wb (&nc->sms, ret);
    return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_number_fax_sms (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    SNode *np = current_number;
    Number_cap *nc = rw (&np->p);
    u8 *fax_sms = rw (&nc->fax_sms);
    u8 l;

    res =
      get_input (locale (lc_FAX_SMS), 0, 100, fax_sms, Q_GET_INPUT_ALPHABET);

    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;

    efree (fax_sms);

    l = res[0];

    if (l < 2)
      fax_sms = NULL;
    else
    {
      res[res[0] + 1] = '\0';
      fax_sms = emalloc (l);
      if (fax_sms == NULL)
      {
	ww (&nc->fax_sms, NULL);
	return perror (ERR_NO_EEPROM);
      }
      memcpy (fax_sms, res + 2, l);
    }
    ww (&nc->fax_sms, fax_sms);

    return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_number_fax_sms_help (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    if (display_text (locale (lc_FAX_SMS_Help), NULL) == APP_END)
      return APP_END;
    return APP_BACK;
  }
  return APP_OK;
}

static u8 PROGMEM ef_sms_path[] = { 0x3F, 0x00, 0x7F, 0x10, 0x6F, 0x3C };

void refsms ()
{
  u8 file_buf[6];

  dbsp (">refresh_sms\n");
  memcpy (file_buf, ef_sms_path, sizeof (ef_sms_path));
  refresh (Q_REFRESH_SIM_FILE_CHANGE, 1, 6, file_buf);
  dbsp ("<refresh_sms\n");
}

void refsms_d (File_apdu_data * fa)
{
  sim (fa->ins, fa->p1, fa->p2, fa->p3, fa->data);
  fa->data[0] = 0;
  sim (fa->ins, fa->p1, fa->p2, fa->p3, fa->data);
  refsms ();
}

u8 alarm_clear_sim_sms (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u16 ret;
    u8 nr_sms;
    u8 rec_len;
    u8 i;
    u8 path[6];

    dbsp ("Clear SIM SMS\n");
    memcpy (path, ef_sms_path, sizeof (ef_sms_path));

    play_tone (locale (lc_Please_Wait), TONE_POSITIVE, DURATION_SEC, 1);
    ret = select (path, 3);
    sim (ME_CMD_GET_RESPONSE, 0, 0, ret, buf_A ());
    nr_sms =
      ((u16) ((u16) (buf_A ()[2]) << 8) | (buf_A ()[3])) / buf_A ()[14];
    rec_len = buf_A ()[14];

    for (i = 0; i < nr_sms; i++)
    {
      dbsp ("DEL SMS ");
      dbch (i + 1);
      dbc ('\n');
      buf_A ()[0] = 0;
      sim (ME_CMD_UPDATE_RECORD, i + 1, 0x04, rec_len, buf_A ());
    }

    select (0, 0);

    refsms ();
    i = display_text (locale (lc_SMS_Deleted), NULL);
    if (i == APP_END)
      return APP_END;
    return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_number_status (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = current_number;
    u8 *text = locale (rw (&n->text));
    Number_cap *nc = rw (&np->p);
    u8 val = rb (&nc->status);

    res = yesno_val (&ret, val, text, NULL);
    if (res != APP_OK)
      return res;
    if (ret != val)
      wb (&nc->status, ret);
    return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_number_send_alarm (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = current_number;
    u8 *text = locale (rw (&n->text));
    Number_cap *nc = rw (&np->p);
    u8 val = rb (&nc->alarm);

    res = yesno_val (&ret, val, text, NULL);
    if (res != APP_OK)
      return res;
    if (ret != val)
      wb (&nc->alarm, ret);
    return APP_BACK;
  }
  return APP_OK;
}

#ifdef CONFIG_TSMS

u8 alarm_number_send_turbo_sms_alarm (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = current_number;
    u8 *text = locale (rw (&n->text));
    Number_cap *nc = rw (&np->p);
    u8 val = rb (&nc->turbo_sms);

    res =
      yesno_val (&ret, val, text,
		 locale (lc_Number_Send_Turbo_SMS_Alarm_Help));
    if (res != APP_OK)
      return res;
    if (ret != val)
      wb (&nc->turbo_sms, ret);
    return APP_BACK;
  }
  return APP_OK;
}

#endif

u8 alarm_number_call_alarm (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = current_number;
    u8 *text = locale (rw (&n->text));
    Number_cap *nc = rw (&np->p);
    u8 val = rb (&nc->alarm_call);

    res = yesno_val (&ret, val, text, NULL);
    if (res != APP_OK)
      return res;
    if (ret != val)
      wb (&nc->alarm_call, ret);
    return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_number_delete (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res;

    res = yesno (NULL, 1, 1);
    if (res == APP_END)
      return APP_END;
    if (res == APP_YES)
    {
      // DELETE
      SEdge *e, *e1;
      SNode *n = ctx->parent->f;
      Number_cap *nc;

      e1 = e = rw (&pers_mem->numbers);
      while (e && rw (&e->t) != n)
      {
	e1 = e;
	e = rw (&e->next);
      }
      if (e)
      {
	if (e == e1)
	  ww (&pers_mem->numbers, rw (&e->next));
	else
	  ww (&e1->next, rw (&e->next));

	efree (e);
	nc = rw (&n->p);
	efree (rw (&nc->nr));
	efree (rw (&nc->fax_sms));
	efree (nc);
	efree (rw (&n->text));
	efree (n);
      }
      spider_back (ctx);
    }
    return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_number_view (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *buf = buf_B ();
    u8 *r = buf;
    SNode *np = current_number;
    Number_cap *nc = rw (&np->p);
    u8 *s = msisdn2str (rw (&nc->nr), MSISDN_ADN, MEM_R);
    u8 i;

    if (s)
    {
      r = sprints (r, s);
      r = sprintc (r, '\0');
      free (s);
      i = display_text (buf, NULL);
      if (i != APP_END)
	return APP_BACK;
      return i;
    }
    else
      return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_number_show (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    current_number = ctx->n;

#ifdef CONFIG_TSMS
    spider_append_r (ctx, &alarm_number_send_turbo_sms_alarm_n);
#endif

    spider_append_r (ctx, &alarm_number_fax_sms_ctx_n);
#ifdef CONFIG_AIRCON
    spider_append_r (ctx, &alarm_number_aircon_n);
#endif

#ifdef CONFIG_BLOCK
    spider_append_r (ctx, &alarm_number_block_n);
#endif

    if (has_mt_call)
    {
      spider_append_r (ctx, &alarm_number_call_confirm_n);
      spider_append_r (ctx, &alarm_number_call_onoff_n);
    }
    spider_append_r (ctx, &alarm_number_sms_onoff_n);
    spider_append_r (ctx, &alarm_number_status_n);
//    spider_append_r (ctx, &alarm_number_call_alarm_n);
    spider_append_r (ctx, &alarm_number_send_alarm_n);
    spider_append_r (ctx, &alarm_number_delete_n);
    spider_append_r (ctx, &alarm_number_view_n);
  }
  else if (action == APP_LEAVE)
  {
    spider_clear_r (ctx);
  }
  return APP_OK;
}

/* *INDENT-OFF* */

lc_char PROGMEM lc_Auto[] = {
  	LC_EN ("Automatic")
	LC_FR ("Automatique")
        LC_DE ("Automatisch")
	LC_CZ ("Automaticky")
	LC_NO ("Automatisk")
	LC_EL("AYTOMATO")
	LC_HU("Automatikus")
	LC_RU("\204\10\33\200\4\20\4\62\4\102\4\76\4\74\4\60\4\102\4\70\4\107\4\65\4\101\4\72\4\70")

	LC_END
};

/* *INDENT-ON* */

#ifdef CONFIG_LANG_CZ
static u8 PROGMEM t_s5[] = "Cesky";
#endif

#ifdef CONFIG_LANG_EN
static u8 PROGMEM t_s6[] = "English";
#endif

#ifdef CONFIG_LANG_DE
static u8 PROGMEM t_s7[] = "Deutsch";
#endif

#ifdef CONFIG_LANG_NO
static u8 PROGMEM t_s8[] = "Norsk";
#endif

#ifdef CONFIG_LANG_FR
static u8 PROGMEM t_s9[] = "Fran\11ais";
#endif

#ifdef CONFIG_LANG_EL
static u8 PROGMEM t_s10[] = "E\24\24HNIKA";
#endif

#ifdef CONFIG_LANG_HU
static u8 PROGMEM t_s11[] = "Magyar";
#endif

#ifdef CONFIG_LANG_RU
static u8 PROGMEM t_s12[] = "Russian";
#endif

static const u8 *PROGMEM l_lang[] = {
#ifdef CONFIG_LANG_CZ
  t_s5,
#endif
#ifdef CONFIG_LANG_EN
  t_s6,
#endif
#ifdef CONFIG_LANG_DE
  t_s7,
#endif
#ifdef CONFIG_LANG_NO
  t_s8,
#endif
#ifdef CONFIG_LANG_FR
  t_s9,
#endif
#ifdef CONFIG_LANG_EL
  t_s10,
#endif
#ifdef CONFIG_LANG_HU
  t_s11,
#endif
#ifdef CONFIG_LANG_RU
  t_s12,
#endif
};

static const u8 PROGMEM lang_hash[] = {
  LC_AUTOMATIC,

#ifdef CONFIG_LANG_CZ
  LC_CZECH,
#endif
#ifdef CONFIG_LANG_EN
  LC_ENGLISH,
#endif
#ifdef CONFIG_LANG_DE
  LC_GERMAN,
#endif
#ifdef CONFIG_LANG_NO
  LC_NORWEGIAN,
#endif
#ifdef CONFIG_LANG_FR
  LC_FRENCH,
#endif
#ifdef CONFIG_LANG_EL
  LC_GREEK,
#endif
#ifdef CONFIG_LANG_HU
  LC_HUNGARIAN,
#endif
#ifdef CONFIG_LANG_RU
  LC_RUSSIAN,
#endif
};

u8 alarm_lang (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    u8 j;
    u8 lang = proc_8 (PROC_8_LANGUAGE);

    j = 0;
    while (rb (lang_hash + j) != lang && j < sizeof (lang_hash))
      j++;
    j++;
    res =
      select_item (sizeof (l_lang) / sizeof (u8 *), l_lang, locale (lc_Lang),
		   locale (lc_Auto), j, Q_SELECT_ITEM_CHOICE);
    j = get_tag (res, T_RESULT);
    if (j != 0)
    {
      j++;			// tag
      j++;			//len
      if (res[j] == 0x10)
	return APP_END;		// end
      if (res[j] == 0x11 || res[j] == 0x12)
	return APP_BACK;	// back
    }

    j = get_tag (res, T_ITEM_ID);
    if (j != 0)
    {
      j++;			//tag
      j++;			//len
      j = res[j];
      j = rb (lang_hash + j - 1);
      if (j != lang)
      {
	set_proc_8 (PROC_8_LANGUAGE, j);
	setmenu (NULL);
	return APP_END;		// to relaunch spider w/ith UCS2
	// TODO what if automatic is Russian ???
      }
    }
    return APP_BACK;
  }
  return APP_OK;
}

#ifdef CONFIG_LANG_EN
u8 PROGMEM t_low_en[] = "Low";
u8 PROGMEM t_mid_en[] = "Medium";
u8 PROGMEM t_hi_en[] = "High";

const u8 *PROGMEM l_sens_en[] = {
  t_low_en,
  t_mid_en,
  t_hi_en
};
#endif

#ifdef CONFIG_LANG_FR
u8 PROGMEM t_low_fr[] = "Bas";
u8 PROGMEM t_mid_fr[] = "Moyen";
u8 PROGMEM t_hi_fr[] = "Haut";

const u8 *PROGMEM l_sens_fr[] = {
  t_low_fr,
  t_mid_fr,
  t_hi_fr
};
#endif

#ifdef CONFIG_LANG_DE
u8 PROGMEM t_low_de[] = "Niedrige";
u8 PROGMEM t_mid_de[] = "Mittlere";
u8 PROGMEM t_hi_de[] = "Hohe";

const u8 *PROGMEM l_sens_de[] = {
  t_low_de,
  t_mid_de,
  t_hi_de
};
#endif

#ifdef CONFIG_LANG_CZ
u8 PROGMEM t_low_cz[] = "Nizka";
u8 PROGMEM t_mid_cz[] = "Stredni";
u8 PROGMEM t_hi_cz[] = "Vysoka";

const u8 *PROGMEM l_sens_cz[] = {
  t_low_cz,
  t_mid_cz,
  t_hi_cz
};
#endif

#ifdef CONFIG_LANG_NO
u8 PROGMEM t_low_no[] = "Lav";
u8 PROGMEM t_mid_no[] = "Medium";
u8 PROGMEM t_hi_no[] = "Hoy";

const u8 *PROGMEM l_sens_no[] = {
  t_low_no,
  t_mid_no,
  t_hi_no
};
#endif

#ifdef CONFIG_LANG_EL
u8 PROGMEM t_low_el[] = "XAMH\24H";
u8 PROGMEM t_mid_el[] = "ME\30AIA";
u8 PROGMEM t_hi_el[] = "Y\27H\24H";

const u8 *PROGMEM l_sens_el[] = {
  t_low_el,
  t_mid_el,
  t_hi_el
};
#endif

#ifdef CONFIG_LANG_HU
u8 PROGMEM t_low_hu[] = "Alacsony";
u8 PROGMEM t_mid_hu[] = "K|zepes";
u8 PROGMEM t_hi_hu[] = "Magas";

const u8 *PROGMEM l_sens_hu[] = {
  t_low_hu,
  t_mid_hu,
  t_hi_hu
};
#endif

#ifdef CONFIG_LANG_RU
u8 PROGMEM t_low_ru[] = "\204\10\15\200\4\35\4\70\4\67\4\72\4\60\4\117";
u8 PROGMEM t_mid_ru[] =
  "\204\10\17\200\4\41\4\100\4\65\4\64\4\75\4\117\4\117";
u8 PROGMEM t_hi_ru[] = "\204\10\17\200\4\22\4\113\4\101\4\76\4\72\4\60\4\117";

const u8 *PROGMEM l_sens_ru[] = {
  t_low_ru,
  t_mid_ru,
  t_hi_ru
};
#endif


/* *INDENT-OFF* */

lc_list PROGMEM lc_Sens[]={
        LC_EN_LIST(l_sens_en)
	LC_FR_LIST(l_sens_fr)
        LC_DE_LIST(l_sens_de)
        LC_CZ_LIST(l_sens_cz)
	LC_NO_LIST(l_sens_no)
	LC_EL_LIST(l_sens_el)
	LC_HU_LIST(l_sens_hu)
	LC_RU_LIST(l_sens_ru)
        LC_END_LIST
};

/* *INDENT-ON* */

u8 alarm_sens (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    u8 j;

    res =
      select_item (3, locale_list (lc_Sens), locale (lc_Sensitivity), NULL,
		   rb (&pers_mem->sens), Q_SELECT_ITEM_CHOICE);

    j = get_tag (res, T_RESULT);
    if (j != 0)
    {
      j++;			// tag
      j++;			//len
      if (res[j] == 0x10)
	return APP_END;		// end
      if (res[j] == 0x11 || res[j] == 0x12)
	return APP_BACK;	// back
    }
    j = get_tag (res, T_ITEM_ID);
    if (j != 0)
    {
      j++;			//tag
      j++;			//len
      if (res[j] != rb (&pers_mem->sens))
      {
	wb (&pers_mem->sens, res[j]);
	if (res[j] == 1)
	{
//LOW
	  alarm_x = alarm_y = DEF_SENS_D_LOW;
	}
	else if (res[j] == 2)
	{
//MEDIUM
	  alarm_x = alarm_y = DEF_SENS_D_MEDIUM;
	}
	else
	{
//HIGH
	  alarm_x = alarm_y = DEF_SENS_D_HIGH;
	}
      }
    }
    return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_poll_interval_delay (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    u8 x;
    u8 *t = buf_B ();
    b8 d;

    d = my_poll_interval (rb (&pers_mem->poll_interval));
    if (d < 0)
      if (display_text (locale (lc_Poll_Interval_Error), NULL) == APP_END)
	return APP_END;

    res = t;
    res = sprinti (res, d);
    res = sprintc (res, '\0');

    res = get_input (locale (lc_Seconds), 1, 2, t, Q_GET_INPUT_DIGITS);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;
    res[res[0] + 1] = '\0';
    x = atoi (&res[2]);
    if (x == 0)
      x = 1;
    d = my_poll_interval (x);
    res = t;
    res = sprints (res, locale (lc_Poll_Interval_Set));
    res = sprinti (res, d);
    res = sprints (res, locale (lc_Seconds_2));
    res = sprintc (res, '\0');
    if (display_text (t, NULL) == APP_END)
      return APP_END;
    if (d != rb (&pers_mem->poll_interval))
      wb (&pers_mem->poll_interval, d);
    return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_poll_interval_help (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    if (display_text (locale (lc_Help_Poll_Interval), NULL) == APP_END)
      return APP_END;
    return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_repeat_alarm_sms_delay (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    u8 x;
    u8 *t = buf_B ();

    res = t;
    res = sprinti (res, rb (&pers_mem->repeated_sms_delay));
    res = sprintc (res, '\0');

    res = get_input (locale (lc_Minutes), 1, 2, t, Q_GET_INPUT_DIGITS);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;
    res[res[0] + 1] = '\0';
    x = atoi (&res[2]);
    if (x != rb (&pers_mem->repeated_sms_delay))
    {
      wb (&pers_mem->repeated_sms_delay, x);
    }
    return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_repeat_alarm_sms_help (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    if (display_text (locale (lc_Help_Repeat_SMS), NULL) == APP_END)
      return APP_END;
    return APP_BACK;
  }
  return APP_OK;
}

#if 0
u8 alarm_status_spawn_bug (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    u8 *text = locale (rw (&n->text));
    u8 val = rb (&pers_mem->status_spawn_bug);

    res = yesno_val (&ret, val, text, locale (lc_Help_Status_Spawn_Bug));
    if (res != APP_OK)
      return res;
    if (ret != val)
      wb (&pers_mem->status_spawn_bug, ret);
    return APP_BACK;
  }
  return APP_OK;
}
#endif

u8 alarm_manual_delay_on (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    u8 x;
    u8 *t = buf_B ();

    res = t;
    res = sprinti (res, rb (&pers_mem->manual_delay_on));
    res = sprintc (res, '\0');

    res = get_input (locale (lc_Minutes), 1, 2, t, Q_GET_INPUT_DIGITS);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;
    res[res[0] + 1] = '\0';
    x = atoi (&res[2]);
    if (x != rb (&pers_mem->manual_delay_on))
    {
      wb (&pers_mem->manual_delay_on, x);
    }
    return APP_BACK;
  }
  return APP_OK;
}

u8 alarm_manual_delay_off (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    u8 x;
    u8 *t = buf_B ();

    res = t;
    res = sprinti (res, rb (&pers_mem->manual_delay_off));
    res = sprintc (res, '\0');

    res = get_input (locale (lc_Minutes), 1, 2, t, Q_GET_INPUT_DIGITS);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;
    res[res[0] + 1] = '\0';
    x = atoi (&res[2]);
    if (x != rb (&pers_mem->manual_delay_off))
    {
      wb (&pers_mem->manual_delay_off, x);
    }
    return APP_BACK;
  }

  return APP_OK;
}

#ifdef CONFIG_NET_RESET
u8 alarm_network_reset (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    u16 x;
    u8 *t = buf_B ();

    res = t;
    res = sprinti (res, rw (&pers_mem->net_reset));
    res = sprintc (res, '\0');

    res = get_input (locale (lc_Minutes), 1, 4, t, Q_GET_INPUT_DIGITS);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;
    res[res[0] + 1] = '\0';
    x = atoi (&res[2]);
    if (x != rw (&pers_mem->net_reset))
    {
      ww (&pers_mem->net_reset, x);
    }
    return APP_BACK;
  }
  return APP_OK;
}
#endif

u8 PROGMEM t_bx[] = "www.bladox.com";
u8 PROGMEM t_sn[] = "SN: ";

#ifdef SMS_FORMAT_NAV
u8 PROGMEM t_nav[] = "NAV\n";
#endif

u8 alarm_version (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *buf = buf_B ();
    u8 *r = buf;
    u8 i;
    u8 sn[16];
    u32 ver = version_turbo ();

//send_status(NULL, 0,0);
//return APP_BACK;

    r = start_ucs2 (r);

#ifdef SMS_FORMAT_NAV
    r = sprints (r, t_nav);
#endif

    r = sprints (r, locale (lc_Version));
    r = sprintc (r, ':');
    r = sprintc (r, ' ');
    r = sprinti (r, (ver >> 24) & 0xFF);
    r = sprintc (r, '.');
    r = sprinti (r, (ver >> 16) & 0xFF);
    r = sprintc (r, '.');
    r = sprinti (r, (ver >> 8) & 0xFF);
//    r = sprintc (r, '.');
//    r = sprinti (r, ver & 0xFF);
    r = sprintc (r, '/');
    r = sprinti (r, VERSION_A);
    r = sprintc (r, '.');
    r = sprinti (r, VERSION_B);
    r = sprintc (r, '.');
    r = sprinti (r, VERSION_C);

    r = sprintc (r, '\n');

    if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER_EVO)
    {
      u8 baby_fw_ver[UART2I2C_FIRMWARE_VERSION_SIZE];

      uart2i2c_read_baby_fw_version (baby_fw_ver,
				     UART2I2C_FIRMWARE_VERSION_SIZE);
      r = sprints (r, locale (lc_Version_baby));
      baby_fw_ver[5] = '\0';
      r = sprints (r, baby_fw_ver);
      r = sprintc (r, '\n');
    }

    r = sprints (r, t_sn);
    serial_number (sn);
    for (i = 0; i < 14; i++)
      r = sprintc (r, sn[i]);
    r = sprintc (r, '\n');

    r = sprints (r, t_bx);

    r = end_ucs2 (r);

    i = display_text (buf, NULL);
    if (i != APP_END)
      return APP_BACK;
    return i;
  }
  return APP_OK;
}

extern SNodeP alarm_n;
extern SNodeP alarm_n_numbers;

u8 alarm_new_number (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    u8 *t;
    u8 *nr;
    SNode *n;
    SEdge *e, *e1;
    u8 j, i;
    u8 alpha[ALPHA_LEN];
    Number_cap *nc;

    res = msisdn (alpha);
    if (res == ENULL)
      goto X1;
    if (res == NULL)
      goto X2;
    n = emalloc (sizeof (SNode));
    if (n == NULL)
      goto X3;
    e = emalloc (sizeof (SEdge));
    if (n == NULL)
      goto X4;
    j = strlen (alpha);
    t = emalloc (j + 1);
    if (t == NULL)
      goto X5;
    nr = msisdncpy (res, MSISDN_ADN, MEM_E);
    if (nr == NULL)
      goto X6;
    memcpy (t, alpha, j);
    wb (t + j, '\0');
    nc = emalloc (sizeof (Number_cap));
    if (nc == NULL)
      goto X7;
    ww (&nc->nr, nr);
    wb (&nc->alarm, 1);
    wb (&nc->alarm_call, 0);
    wb (&nc->status, 1);
    wb (&nc->sms, 1);
    wb (&nc->call, 1);
    wb (&nc->call_confirm, 0);
    wb (&nc->turbo_sms, 0);
    ww (&nc->fax_sms, 0);

#ifdef CONFIG_BLOCK
    wb (&nc->block, 1);
#endif
#ifdef CONFIG_AIRCON
    wb (&nc->aircon, 1);
#endif

    ww (&n->cb, alarm_number_show);
    ww (&n->text, t);
    ww (&n->p, nc);

    ww (&e->next, rw (&pers_mem->numbers));
    ww (&e->t, n);
    ww (&e->f, &alarm_n_numbers);
    wb (&e->source, MEM_F_P | MEM_T_E);
    ww (&pers_mem->numbers, e);
    goto X2;
  X7:
    efree (nr);
  X6:
    efree (t);
  X5:
    efree (e);
  X4:
    efree (n);
  X3:
    perror (ERR_NO_EEPROM);
  X2:
    return APP_BACK;
  X1:
    return APP_END;
  }
  return APP_OK;
}

void set_cancel_alarm2_on ()
{
  if (OUTPUT_ACTIVE_LEVEL == LEVEL_HIGH)
  {
    sbi (ALARM_OUT_CANCEL_ALARM2_PORT, ALARM_OUT_CANCEL_ALARM2_PORT_PIN);	//set ALARM_OUT_CANCEL_ALARM2 pin output register bit to log.1
  }
  else
  {
    cbi (ALARM_OUT_CANCEL_ALARM2_PORT, ALARM_OUT_CANCEL_ALARM2_PORT_PIN);	//set ALARM_OUT_CANCEL_ALARM2 pin output register bit to log.0
  }
  asm __volatile__ ("nop");	//wait
}

void set_cancel_alarm2_off ()
{
  if (OUTPUT_ACTIVE_LEVEL == LEVEL_HIGH)
  {
    cbi (ALARM_OUT_CANCEL_ALARM2_PORT, ALARM_OUT_CANCEL_ALARM2_PORT_PIN);	//set ALARM_OUT_CANCEL_ALARM2 pin output register bit to log.0
  }
  else
  {
    sbi (ALARM_OUT_CANCEL_ALARM2_PORT, ALARM_OUT_CANCEL_ALARM2_PORT_PIN);	//set ALARM_OUT_CANCEL_ALARM2 pin output register bit to log.1
  }
  asm __volatile__ ("nop");	//wait
}

void opto_out_1_on ()
{
  if ((version_hwd () != TURBO_SIM_TOOLKIT_ADAPTER))
  {
    if (OUTPUT_ACTIVE_LEVEL == LEVEL_HIGH)
    {
      sbi (ALARM_OUT_EVO_AIRCON_PORT, ALARM_OUT_EVO_AIRCON_PORT_PIN);	//set ALARM_OUT_EVO_AIRCON pin output register bit to log.1
    }
    else
    {
      cbi (ALARM_OUT_EVO_AIRCON_PORT, ALARM_OUT_EVO_AIRCON_PORT_PIN);	//set ALARM_OUT_EVO_AIRCON pin output register bit to log.0
    }
  }
  asm __volatile__ ("nop");	//wait
}

void opto_out_1_off ()
{
  if ((version_hwd () != TURBO_SIM_TOOLKIT_ADAPTER))
  {
    if (OUTPUT_ACTIVE_LEVEL == LEVEL_HIGH)
    {
      cbi (ALARM_OUT_EVO_AIRCON_PORT, ALARM_OUT_EVO_AIRCON_PORT_PIN);	//set ALARM_OUT_EVO_AIRCON pin output register bit to log.0
    }
    else
    {
      sbi (ALARM_OUT_EVO_AIRCON_PORT, ALARM_OUT_EVO_AIRCON_PORT_PIN);	//set ALARM_OUT_EVO_AIRCON pin output register bit to log.1
    }
  }
  asm __volatile__ ("nop");	//wait
}

void set_ac_on ()
{
  u8 ac = 0;

#ifdef CONFIG_OPTO_OUT_1_PULSE
// AC always P11
  ac = 1;
#endif

  is_aircon = 1;
  if (OUTPUT_ACTIVE_LEVEL == LEVEL_HIGH)
  {
    if ((version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER) || ac)
      sbi (ALARM_OUT_AIRCON_PORT, ALARM_OUT_AIRCON_PORT_PIN);	//set ALARM_OUT_AIRCON pin output register bit to log.1
    else
      sbi (ALARM_OUT_EVO_AIRCON_PORT, ALARM_OUT_EVO_AIRCON_PORT_PIN);	//set ALARM_OUT_EVO_AIRCON pin output register bit to log.1
  }
  else
  {
    if ((version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER) || ac)
      cbi (ALARM_OUT_AIRCON_PORT, ALARM_OUT_AIRCON_PORT_PIN);	//set ALARM_OUT_AIRCON pin output register bit to log.0
    else
      cbi (ALARM_OUT_EVO_AIRCON_PORT, ALARM_OUT_EVO_AIRCON_PORT_PIN);	//set ALARM_OUT_EVO_AIRCON pin output register bit to log.0
  }
  asm __volatile__ ("nop");	//wait
}

void set_ac_off ()
{
  u8 ac = 0;

#ifdef CONFIG_OPTO_OUT_1_PULSE
// AC always P11
  ac = 1;
#endif

  is_aircon = 0;
  if (OUTPUT_ACTIVE_LEVEL == LEVEL_HIGH)
  {
    if ((version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER) || ac)
      cbi (ALARM_OUT_AIRCON_PORT, ALARM_OUT_AIRCON_PORT_PIN);	//set ALARM_OUT_AIRCON pin output register bit to log.0
    else
      cbi (ALARM_OUT_EVO_AIRCON_PORT, ALARM_OUT_EVO_AIRCON_PORT_PIN);	//set ALARM_OUT_EVO_AIRCON pin output register bit to log.0
  }
  else
  {
    if ((version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER) || ac)
      sbi (ALARM_OUT_AIRCON_PORT, ALARM_OUT_AIRCON_PORT_PIN);	//set ALARM_OUT_AIRCON pin output register bit to log.1
    else
      sbi (ALARM_OUT_EVO_AIRCON_PORT, ALARM_OUT_EVO_AIRCON_PORT_PIN);	//set ALARM_OUT_EVO_AIRCON pin output register bit to log.1
  }
  asm __volatile__ ("nop");	//wait
}

void set_alarm_on ()
{
  if (OUTPUT_ACTIVE_LEVEL == LEVEL_HIGH)
  {
    sbi (ALARM_OUT_ALARM_PORT, ALARM_OUT_ALARM_PORT_PIN);	//set ALARM_OUT_ALARM pin output register bit to log.1
  }
  else
  {
    cbi (ALARM_OUT_ALARM_PORT, ALARM_OUT_ALARM_PORT_PIN);	//set ALARM_OUT_ALARM pin output register bit to log.0
  }
  asm __volatile__ ("nop");	//wait
}

void set_alarm_off ()
{
  if (OUTPUT_ACTIVE_LEVEL == LEVEL_HIGH)
  {
    cbi (ALARM_OUT_ALARM_PORT, ALARM_OUT_ALARM_PORT_PIN);	//set ALARM_OUT_ALARM pin output register bit to log.0
  }
  else
  {
    sbi (ALARM_OUT_ALARM_PORT, ALARM_OUT_ALARM_PORT_PIN);	//set ALARM_OUT_ALARM pin output register bit to log.1
  }
  asm __volatile__ ("nop");	//wait
}

void set_active_on ()
{
  if (OUTPUT_ACTIVE_LEVEL == LEVEL_HIGH)
  {
    sbi (ALARM_OUT_ACTIVE_PORT, ALARM_OUT_ACTIVE_PORT_PIN);	//set ALARM_OUT_ACTIVE pin output register bit to log.1
  }
  else
  {
    cbi (ALARM_OUT_ACTIVE_PORT, ALARM_OUT_ACTIVE_PORT_PIN);	//set ALARM_OUT_ACTIVE pin output register bit to log.0
  }
  asm __volatile__ ("nop");	//wait
}

void set_active_off ()
{
  if (OUTPUT_ACTIVE_LEVEL == LEVEL_HIGH)
  {
    cbi (ALARM_OUT_ACTIVE_PORT, ALARM_OUT_ACTIVE_PORT_PIN);	//set ALARM_OUT_ACTIVE pin output register bit to log.0
  }
  else
  {
    sbi (ALARM_OUT_ACTIVE_PORT, ALARM_OUT_ACTIVE_PORT_PIN);	//set ALARM_OUT_ACTIVE pin output register bit to log.1
  }
  asm __volatile__ ("nop");	//wait
}

void set_alarm_btn ()
{
  if (OUTPUT_ACTIVE_LEVEL == LEVEL_HIGH)
  {
    sbi (ALARM_OUT_ALARM_BTN_PORT, ALARM_OUT_ALARM_BTN_PORT_PIN);	//set ALARM_OUT_ALARM_BTN pin output register bit to log.1
  }
  else
  {
    cbi (ALARM_OUT_ALARM_BTN_PORT, ALARM_OUT_ALARM_BTN_PORT_PIN);	//set ALARM_OUT_ALARM_BTN pin output register bit to log.0
  }
  asm __volatile__ ("nop");	//wait

// wait 1 sec
  {
    u16 i;

    for (i = 0; i < 1000; i++)
      delay_1ms ();
  }
  if (OUTPUT_ACTIVE_LEVEL == LEVEL_HIGH)
  {
    cbi (ALARM_OUT_ALARM_BTN_PORT, ALARM_OUT_ALARM_BTN_PORT_PIN);	//set ALARM_OUT_ALARM_BTN pin output register bit to log.0
  }
  else
  {
    sbi (ALARM_OUT_ALARM_BTN_PORT, ALARM_OUT_ALARM_BTN_PORT_PIN);	//set ALARM_OUT_ALARM_BTN pin output register bit to log.1
  }
  asm __volatile__ ("nop");	//wait
}

void set_brake_lights_off ()
{
  is_brake_lights = 0;
  if (OUTPUT_ACTIVE_LEVEL == LEVEL_HIGH)
  {
    cbi (ALARM_OUT_BRAKE_PORT, ALARM_OUT_BRAKE_PORT_PIN);	//set ALARM_OUT_BRAKE pin output register bit to log.0
  }
  else
  {
    sbi (ALARM_OUT_BRAKE_PORT, ALARM_OUT_BRAKE_PORT_PIN);	//set ALARM_OUT_BRAKE pin output register bit to log.1
  }
  asm __volatile__ ("nop");	//wait
}

void set_brake_lights_on ()
{
  is_brake_lights = 1;
  if (OUTPUT_ACTIVE_LEVEL == LEVEL_HIGH)
  {
    sbi (ALARM_OUT_BRAKE_PORT, ALARM_OUT_BRAKE_PORT_PIN);	//set ALARM_OUT_BRAKE pin output register bit to log.1
  }
  else
  {
    cbi (ALARM_OUT_BRAKE_PORT, ALARM_OUT_BRAKE_PORT_PIN);	//set ALARM_OUT_BRAKE pin output register bit to log.0
  }
  asm __volatile__ ("nop");	//wait
}

void set_block_on ()
{
  is_brake_lights = 0;
  is_blocked = 1;
  if (OUTPUT_ACTIVE_LEVEL == LEVEL_HIGH)
  {
    if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER)
      sbi (ALARM_OUT_BLOCK_PORT, ALARM_OUT_BLOCK_PORT_PIN);	//set ALARM_OUT_BLOCK pin output register bit to log.1
    else
      sbi (ALARM_OUT_EVO_BLOCK_PORT, ALARM_OUT_EVO_BLOCK_PORT_PIN);	//set ALARM_OUT_EVO_BLOCK pin output register bit to log.1
  }
  else
  {
    if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER)
      cbi (ALARM_OUT_BLOCK_PORT, ALARM_OUT_BLOCK_PORT_PIN);	//set ALARM_OUT_BLOCK pin output register bit to log.0
    else
      cbi (ALARM_OUT_EVO_BLOCK_PORT, ALARM_OUT_EVO_BLOCK_PORT_PIN);	//set ALARM_OUT_EVO_BLOCK pin output register bit to log.0
  }
  asm __volatile__ ("nop");	//wait
}

void set_block_off ()
{
  if (is_brake_lights)
    set_brake_lights_off ();
  if (is_blocked)
  {
    if (OUTPUT_ACTIVE_LEVEL == LEVEL_HIGH)
    {
      if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER)
	cbi (ALARM_OUT_BLOCK_PORT, ALARM_OUT_BLOCK_PORT_PIN);	//set ALARM_OUT_BLOCK pin output register bit to log.0
      else
	cbi (ALARM_OUT_EVO_BLOCK_PORT, ALARM_OUT_EVO_BLOCK_PORT_PIN);	//set ALARM_OUT_EVO_BLOCK pin output register bit to log.0
    }
    else
    {
      if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER)
	sbi (ALARM_OUT_BLOCK_PORT, ALARM_OUT_BLOCK_PORT_PIN);	//set ALARM_OUT_BLOCK pin output register bit to log.1
      else
	sbi (ALARM_OUT_EVO_BLOCK_PORT, ALARM_OUT_EVO_BLOCK_PORT_PIN);	//set ALARM_OUT_EVO_BLOCK pin output register bit to log.1
    }
    asm __volatile__ ("nop");	//wait
  }
  is_blocked = 0;
}

u8 get_central_lock ()
{
  u8 pinVal;
  u8 tmp = is_locked;

  if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER)
    pinVal = ((inb (ALARM_IN_CENTRAL_PIN) & (1 << ALARM_IN_CENTRAL_PIN_PIN)));
  else
    pinVal =
      ((inb (ALARM_IN_EVO_CENTRAL_PIN) &
	(1 << ALARM_IN_EVO_CENTRAL_PIN_PIN)));

  if (pinVal != 0)
    pinVal = LEVEL_HIGH;
  else
    pinVal = LEVEL_LOW;

  return pinVal;
}

u8 get_alarm_1 ()
{
  u8 pinVal;

  if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER)
    pinVal = ((inb (ALARM_IN_ALARM1_PIN) & (1 << ALARM_IN_ALARM1_PIN_PIN)));
  else
    pinVal =
      ((inb (ALARM_IN_EVO_ALARM1_PIN) & (1 << ALARM_IN_EVO_ALARM1_PIN_PIN)));

  if (pinVal != 0)
    pinVal = LEVEL_HIGH;
  else
    pinVal = LEVEL_LOW;
  return pinVal;
}

u8 get_alarm_2 ()
{
  u8 pinVal;

  pinVal = ((inb (ALARM_IN_ALARM2_PIN) & (1 << ALARM_IN_ALARM2_PIN_PIN)));
  if (pinVal != 0)
    pinVal = LEVEL_HIGH;
  else
    pinVal = LEVEL_LOW;
  return pinVal;
}

u8 get_panic ()
{
  u8 pinVal;

  pinVal = ((inb (ALARM_IN_PANIC_PIN) & (1 << ALARM_IN_PANIC_PIN_PIN)));
  if (pinVal != 0)
    pinVal = LEVEL_HIGH;
  else
    pinVal = LEVEL_LOW;
  return pinVal;
}

u8 get_aircon ()
{
  u8 pinVal;

  pinVal = ((inb (ALARM_IN_AIRCON_PIN) & (1 << ALARM_IN_AIRCON_PIN_PIN)));
  if (pinVal != 0)
    pinVal = LEVEL_HIGH;
  else
    pinVal = LEVEL_LOW;
  return pinVal;
}

void manual_unlock ()
{
  reset_vals ();
  set_block_off ();
  play_tone (locale (lc_Alarm_Unlocked), TONE_POSITIVE, DURATION_SEC,
	     DEF_PLAY_DURATION);
  set_idle_text ();
}

void manual_lock ()
{
  reset_vals ();
  was_manual_lock = 1;
  is_locked = 1;
  if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER_EVO)
  {
    accel_flush ();
    uart2i2c_write_interval (accel_interval);
  }
  manual_lock_time = cur_time;

#ifdef CONFIG_OLD
  nr_count = 0;
  x_max = 0;
  y_max = 0;
  nr_alarm = 0;
  x_burst_min = 0xFFFF;
  y_burst_min = 0xFFFF;
  x_burst_max = 0;
  y_burst_max = 0;
#endif

  play_tone (locale (lc_Alarm_Locked), TONE_POSITIVE, DURATION_SEC,
	     DEF_PLAY_DURATION);
  set_idle_text ();
}

//SNodeP alarm_n = { lc_Alarm, alarm_ctx };
SNodeP alarm_n_config = { lc_Alarm_Config, NULL };
SNodeP alarm_pin_prot_n = { lc_Protect_PIN, alarm_pin_prot };

SNodeP alarm_measure_n = { lc_Measure, NULL };

//SNodeP alarm_gps_n = { lc_GPS, alarm_show_gps };
SNodeP alarm_gps_n = { lc_GPS, NULL };
SNodeP alarm_measure_show_n = { LC_VIEW, alarm_measure_show };
SNodeP alarm_measure_help_n = { lc_Help, alarm_measure_help };
SNodeP alarm_measure_set_new_n = { lc_SetNew, accel_new_interval_delay };
SNodeP alarm_gps_show_n = { LC_VIEW, alarm_show_gps };
SNodeP alarm_gps_set_n = { lc_Baudrate, alarm_set_gps };

//SNodeP alarm_gps_set_interval_n = { lc_NmeaInterval, alarm_set_gps_interval_nmea };
SNodeP alarm_gps_init_n = { lc_InitGps, alarm_init_gps };

//SNodeP alarm_gps_read_n = { lc_Read, alarm_read_gps };
SNodeP alarm_n_new_number = { lc_New_Number, alarm_new_number };
SNodeP alarm_n_numbers = { lc_Numbers, alarm_numbers };
SNodeP alarm_lang_n = { lc_Lang, alarm_lang };
SNodeP alarm_sens_n = { lc_Sensitivity, alarm_sens };
SNodeP alarm_manual_delay_on_n =
  { lc_Manual_Delay_On, alarm_manual_delay_on };
SNodeP alarm_manual_delay_off_n =
  { lc_Manual_Delay_Off, alarm_manual_delay_off };
SNodeP alarm_repeat_alarm_sms_n = { lc_Repeat_Alarm_SMS, NULL };
SNodeP alarm_repeat_alarm_sms_delay_n =
  { lc_Delay, alarm_repeat_alarm_sms_delay };
SNodeP alarm_repeat_alarm_sms_help_n =
  { lc_Help, alarm_repeat_alarm_sms_help };
#if 0
SNodeP alarm_status_spawn_bug_n =
  { lc_Status_Spawn_Bug, alarm_status_spawn_bug };
#endif

SNodeP alarm_poll_interval_n = { lc_Poll_Interval, NULL };
SNodeP alarm_poll_interval_delay_n =
  { lc_Poll_Interval, alarm_poll_interval_delay };
SNodeP alarm_poll_interval_help_n = { lc_Help, alarm_poll_interval_help };

#ifdef CONFIG_NET_RESET
SNodeP alarm_network_reset_n = { lc_Network_Reset, alarm_network_reset };
#endif

SNodeP alarm_version_n = { lc_Version, alarm_version };
SNodeP alarm_central_lock_n = { lc_Central_lock, alarm_central_lock };
SNodeP alarm_alarm_1_n = { lc_Alarm_1, alarm_alarm_1 };
SNodeP alarm_alarm_2_n = { lc_Alarm_2, alarm_alarm_2 };
SNodeP alarm_clear_sim_sms_n = { lc_Clear_SIM_SMS, alarm_clear_sim_sms };

SNodeP alarm_number_view_n = { LC_VIEW, alarm_number_view };
SNodeP alarm_number_delete_n = { LC_DELETE, alarm_number_delete };
SNodeP alarm_number_send_alarm_n =
  { lc_Number_Send_Alarm, alarm_number_send_alarm };

#ifdef CONFIG_TSMS
SNodeP alarm_number_send_turbo_sms_alarm_n =
  { lc_Number_Send_Turbo_SMS_Alarm, alarm_number_send_turbo_sms_alarm };
#endif

SNodeP alarm_number_call_alarm_n =
  { lc_Number_Call_Alarm, alarm_number_call_alarm };
SNodeP alarm_number_status_n = { lc_Number_Status, alarm_number_status };
SNodeP alarm_number_sms_onoff_n =
  { lc_Number_SMS_Onoff, alarm_number_sms_onoff };
SNodeP alarm_number_fax_sms_ctx_n = { lc_FAX_SMS, alarm_number_fax_sms_ctx };
SNodeP alarm_number_fax_sms_n = { LC_EDIT, alarm_number_fax_sms };
SNodeP alarm_number_fax_sms_help_n = { lc_Help, alarm_number_fax_sms_help };
SNodeP alarm_number_call_onoff_n =
  { lc_Number_Call_Onoff, alarm_number_call_onoff };
SNodeP alarm_number_call_confirm_n =
  { lc_Number_Call_Confirm, alarm_number_call_confirm };

#ifdef CONFIG_BLOCK
SNodeP alarm_number_block_n = { lc_Number_Block, alarm_number_block };
#endif

#ifdef CONFIG_AIRCON
SNodeP alarm_number_aircon_n = { lc_Number_Aircon, alarm_number_aircon };
#endif

/* *INDENT-OFF* */

SEdgeP alarm_edges_p[] = {
  {&alarm_n_numbers, &alarm_n_new_number},
  {&alarm_n_config, &alarm_lang_n},
  {&alarm_n_config, &alarm_version_n},
  {&alarm_n_config, &alarm_sens_n},
  {&alarm_n_config, &alarm_manual_delay_on_n},
  {&alarm_n_config, &alarm_manual_delay_off_n},
  {&alarm_n_config, &alarm_repeat_alarm_sms_n},
  {&alarm_n_config, &alarm_pin_prot_n},
  {&alarm_n_config, &alarm_poll_interval_n},
//  {&alarm_n_config, &alarm_status_spawn_bug_n},
  {&alarm_n_config, &alarm_measure_n},
#ifdef DEF_AA_2
  {&alarm_n_config, &alarm_gps_n},
  {&alarm_gps_n, &alarm_gps_show_n},
  {&alarm_gps_n, &alarm_gps_set_n},
//  {&alarm_gps_n, &alarm_gps_set_interval_n},
//  {&alarm_gps_n, &alarm_gps_init_n},
//  {&alarm_gps_n, &alarm_gps_read_n},
#endif
  {&alarm_n_config, &alarm_clear_sim_sms_n},
#ifdef CONFIG_NET_RESET
  {&alarm_n_config, &alarm_network_reset_n},
#endif
  {&alarm_n_config, &alarm_central_lock_n},
  {&alarm_n_config, &alarm_alarm_1_n},
  {&alarm_n_config, &alarm_alarm_2_n},
  {&alarm_repeat_alarm_sms_n, &alarm_repeat_alarm_sms_delay_n},
  {&alarm_repeat_alarm_sms_n, &alarm_repeat_alarm_sms_help_n},
  {&alarm_poll_interval_n, &alarm_poll_interval_delay_n},
  {&alarm_poll_interval_n, &alarm_poll_interval_help_n},
  {&alarm_measure_n, &alarm_measure_show_n},
  {&alarm_measure_n, &alarm_measure_help_n},
//  {&alarm_measure_n, &alarm_measure_set_new_n},
  NULL
};

/* *INDENT-ON* */

#ifdef CONFIG_AIRCON
static u8 PROGMEM t_keyword_ac_on[] = "AC ON";
static u8 PROGMEM t_keyword_ac_off[] = "AC OFF";
#endif

#ifdef CONFIG_BLOCK
static u8 PROGMEM t_keyword_block_on[] = "BLOCK ON";
static u8 PROGMEM t_keyword_block_off[] = "BLOCK OFF";
#endif

static u8 PROGMEM t_keyword_alarm_off[] = "ALARM OFF";
static u8 PROGMEM t_keyword_off[] = "OFF";
static u8 PROGMEM t_keyword_on[] = "ON";

static u8 PROGMEM t_LACCID[] = "LAC/CID: ";
static u8 PROGMEM t_NET[] = "NET: ";

static u8 PROGMEM t_TSMS_HEAD[] = "AASTAT1";

#ifdef SMS_FORMAT_NAV
static u8 PROGMEM t_nav_sms_1[] = "#NAV;;;;";
static u8 PROGMEM t_nav_sms_2[] = ";Sent by AA ";

//static u8 PROGMEM t_test_lat[] = "3806.583";
//static u8 PROGMEM t_test_long[] = "02350.247";

static u8 PROGMEM t_zero_lat[] = "0000.000";
static u8 PROGMEM t_zero_long[] = "00000.000";

#endif

u8 send_status (u8 * ms, u8 type, u8 tsms)	// 0 - failed, 1 - sent ok
{
  u8 *tmp = malloc (200);
  u8 *r = tmp;
  u8 *s;
  u8 i, j, nr_rep;
  u16 val;
  u8 a = 0;
  u8 gps = 0;
  u8 dcs;
  u8 off;

  dbsp (">send_status\n");

  if (tmp != NULL)
  {
    r = start_ucs2 (r);

#ifdef SMS_FORMAT_NAV
    u16 x_h;
    double x_sf;
    u8 *t;

    actualizePositionGps ();

    r = sprints (r, t_nav_sms_1);

    if (gpsData->latitude[0] == '\0')
      memcpy (gpsData->latitude, t_zero_lat, strlen (t_zero_lat) + 1);
    i = 0;
    t = gpsData->latitude;
    while (t[i] != '.')
      i++;
    x_h = (t[i - 4] - '0') * 10 + (t[i - 3] - '0');
//dbsp("H: ");dbih(x_h);dbc('\n');
    i -= 2;
    x_sf = atof (&t[i]);
    x_sf = x_h + x_sf / 60.0;

    dtostrf (x_sf, 8, 5, r);
    r += 8;

    r = sprintc (r, ';');

    if (gpsData->longitude[0] == '\0')
      memcpy (gpsData->longitude, t_zero_long, strlen (t_zero_long) + 1);
    i = 0;
    t = gpsData->longitude;
    while (t[i] != '.')
      i++;
    x_h =
      ((u16) (t[i - 5] - '0')) * 100 + (t[i - 4] - '0') * 10 + (t[i - 3] -
								'0');
//dbsp("H: ");dbih(x_h);dbc('\n');
    i -= 2;
    x_sf = atof (&t[i]);
    x_sf = x_h + x_sf / 60.0;

    dtostrf (x_sf, 8, 5, r);
    r += 8;

    r = sprints (r, t_nav_sms_2);

    if (get_panic () == INPUT_ACTIVE_LEVEL)
    {
      a = 1;
      r = sprints (r, locale (lc_SMS_Alarm_Panic));
    }

    if (is_alarm_accel)
    {
      a = 1;
      r = sprints (r, locale (lc_SMS_Alarm_Accel));
    }

    if (is_alarm_1)
    {
      a = 1;
      r = sprints (r, locale (lc_SMS_Alarm_1));
    }

    if (is_alarm_2)
    {
      a = 1;
      r = sprints (r, locale (lc_SMS_Alarm_2));
    }

#ifdef DEBUG
    dbsp ("NAV: ");
    for (i = 0; i < r - tmp; i++)
      dbc (tmp[i]);
    dbc ('\n');
#endif

#else
    if (tsms)
      r = sprints (r, t_TSMS_HEAD);

    if (get_panic () == INPUT_ACTIVE_LEVEL)
    {
      a = 1;
      r = sprints (r, locale (lc_SMS_Alarm_Panic));
    }

    if (is_alarm_accel)
    {
      a = 1;
      r = sprints (r, locale (lc_SMS_Alarm_Accel));
    }

    if (is_alarm_1)
    {
      a = 1;
      r = sprints (r, locale (lc_SMS_Alarm_1));
    }

    if (is_alarm_2)
    {
      a = 1;
      r = sprints (r, locale (lc_SMS_Alarm_2));
    }

    if (a == 0)
    {
// Locked:
      r = sprints (r, locale (lc_Status_Locked));
      if (is_locked)
	r = sprints (r, locale (lc_SMS_Yes));
      else
	r = sprints (r, locale (lc_SMS_No));
      r = sprintc (r, '\n');
    }

/*
    if (a == 0 && rb (&pers_mem->central_lock))
    {
// Central:
      r = sprints (r, locale (lc_Status_Central));
      if (get_central_lock () == INPUT_ACTIVE_LEVEL)
	r = sprints (r, locale (lc_SMS_Yes));
      else
	r = sprints (r, locale (lc_SMS_No));
      r = sprintc (r, '\n');
    }

    if (a == 0)
    {
// Alarm:
      r = sprints (r, locale (lc_Status_Alarm));
      if (is_alarm_accel)
	r = sprints (r, locale (lc_SMS_Yes));
      else
	r = sprints (r, locale (lc_SMS_No));
      r = sprintc (r, '\n');
    }

    if (a == 0 && rb (&pers_mem->alarm_1))
    {
// Alarm_1:
      r = sprints (r, locale (lc_Status_Alarm_1));
      if (is_alarm_1)
	r = sprints (r, locale (lc_SMS_Yes));
      else
	r = sprints (r, locale (lc_SMS_No));
      r = sprintc (r, '\n');
    }

    if (a == 0 && rb (&pers_mem->alarm_2))
    {
// Alarm_2:
      r = sprints (r, locale (lc_Status_Alarm_2));
      if (is_alarm_2)
	r = sprints (r, locale (lc_SMS_Yes));
      else
	r = sprints (r, locale (lc_SMS_No));
      r = sprintc (r, '\n');
    }
*/

#ifdef CONFIG_BLOCK
    if (1 /*a == 0 */ )
    {
// Blocked:
      r = sprints (r, locale (lc_Status_Blocked));
      if (is_blocked)
	r = sprints (r, locale (lc_SMS_Yes));
      else
	r = sprints (r, locale (lc_SMS_No));
      r = sprintc (r, '\n');
    }
#endif

#ifdef CONFIG_AIRCON
    if (1 /*a == 0 */ )
    {
// Aircon:
      r = sprints (r, locale (lc_Status_AC));
      if (is_aircon)
	r = sprints (r, locale (lc_SMS_Yes));
      else
	r = sprints (r, locale (lc_SMS_No));
      r = sprintc (r, '\n');
    }
#endif

    if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER_EVO)
    {
      actualizePositionGps ();

      if (gpsData->latitude[0] != '\0')
      {
	gps = 1;

//16
	r = sprints (r, t_gpsData_LATITUDE);	//3
	r = sprints (r, gpsData->latitude);	//10
	r = sprints (r, gpsData->latitudeH);	//2
	r = sprintc (r, '\n');

//16
	r = sprints (r, t_gpsData_LONGITUDE);	//3
	r = sprints (r, gpsData->longitude);	//10
	r = sprints (r, gpsData->longitudeH);	//2
	r = sprintc (r, '\n');

//10
	r = sprints (r, t_gpsData_COURSE);	//3
	r = sprints (r, gpsData->course);	//6
	r = sprintc (r, '\n');

//11
	r = sprints (r, t_gpsData_SPEED);	//3
	r = sprints (r, gpsData->speed);	//7
	r = sprintc (r, '\n');

/*
      r = sprints (r, t_gpsData_UTC);
      r = sprints (r, gpsData->utcTime);	//9
      r = sprintc (r, '\n');

      r = sprints (r, t_gpsData_DATE);
      r = sprints (r, gpsData->date);		//6
      r = sprintc (r, '\n');
*/
/*
      __dbs(gpsData->latitude);
      __dbs(gpsData->latitudeH);
      __dbs("\n");
      __dbs(gpsData->longitude);	
      __dbs(gpsData->longitudeH);	
      __dbs("\n");
      __dbs(gpsData->course);	
      __dbs("\n");
      __dbs(gpsData->speed);	
      __dbs("\n");
      __dbs(gpsData->utcTime);	
      __dbs("\n");
      __dbs(gpsData->date);		
      __dbs("\n");
*/
      }
    }

    s = provide_local_info ();
    j = get_tag (s, T_LOCATION_INFO);
    if (tsms)
    {
      r = sprintc (r, '\0');
      if (j != 0)
      {
	j += 2;
	r = sprintc (r, 0xff);
	r = sprintc (r, (s[j]) & 0x0f);
	r = sprintc (r, (s[j] >> 4) & 0x0f);

	r = sprintc (r, (s[j + 1]) & 0x0f);
	r = sprintc (r, (s[j + 1] >> 4) & 0x0f);

	r = sprintc (r, (s[j + 2]) & 0x0f);
	r = sprintc (r, (s[j + 2] >> 4) & 0x0f);

	r = sprintc (r, (s[j + 3]) & 0x0f);
	r = sprintc (r, (s[j + 3] >> 4) & 0x0f);

	r = sprintc (r, (s[j + 4]) & 0x0f);
	r = sprintc (r, (s[j + 4] >> 4) & 0x0f);

	r = sprintc (r, (s[j + 5]) & 0x0f);
	r = sprintc (r, (s[j + 5] >> 4) & 0x0f);

	r = sprintc (r, (s[j + 6]) & 0x0f);
	r = sprintc (r, (s[j + 6] >> 4) & 0x0f);
      }
      else
      {
	r = sprintc (r, '\0');
      }
    }
    else
    {
      if (j != 0)
      {
	j += 2;

	if (1 /*a==1 || (a==0 && gps=0 */ )
	{
	  r = sprints (r, t_NET);
	  r = sprintch (r, swap_nibble (s[j]));
	  r = sprintch (r, swap_nibble (s[j + 1]));
	  r = sprintch (r, swap_nibble (s[j + 2]));
	  r = sprintc (r, '/');
/*
	  r = sprintc (r, '\n');

	  r = sprints (r, t_LACCID);
*/
	  r = sprintch (r, s[j + 3]);
	  r = sprintch (r, s[j + 4]);
	  r = sprintc (r, '/');
	  r = sprintch (r, s[j + 5]);
	  r = sprintch (r, s[j + 6]);
	  r = sprintc (r, '\n');
	}
      }
    }

/*
#ifdef CONFIG_MEASURE
  r = sprints (r, t_X_max);
  r = sprinti (r, max_dx);
  r = sprintc (r, '\n');
  r = sprints (r, t_Y_max);
  r = sprinti (r, max_dy);
  r = sprintc (r, '\n');

  if (is_alarm_accel)
  {
    r = sprints (r, t_dXY);
    r = sprinti (r, dx);
    r = sprintc (r, '/');
    r = sprinti (r, dy);
    r = sprintc (r, '\n');
  }
#endif
*/
#endif

    r = end_ucs2 (r);

    dbsp ("SEND_SMS ");
    dbih (r - tmp);
    dbc ('\n');

    if (proc_8 (PROC_8_LANGUAGE) == LC_RUSSIAN)
    {
      i = tmp[2] - 1;		// len minus trailing UCS2 0x80
      if (i > 140)
	i = 140;
      dcs = DCS_UCS2;
      off = 4;			// skip STRING_SLV, DCS, LEN, 0x80
    }
    else
    {
      r--;			// remove \0 appened by end_ucs2()

      if (tsms)
	dcs = 0x12;
      else
	dcs = 0x00;

      i = dcs_78 (tmp, r - tmp, DCS_8_TO_7);
      if (i > 160)
	i = 160;
      off = 0;
    }

    nr_rep = 0;

  X_REP:
    r = send_sms (tmp + off, i, ms, type, dcs, 0, NULL, NULL);
    nr_rep++;

    j = get_tag (r, T_RESULT);
    if (j != 0)
    {
      j += 2;
      if (r[j] == 0x00)
      {
	free (tmp);
	dbsp ("SEND_SMS OK\n");
	return 1;
      }
      else
      {
	dbsp ("SEND_SMS NOT OK\n");
	if (nr_rep > 5)
	{
	  free (tmp);
	  return 0;
	}
	else
	  goto X_REP;
      }
    }
  }
  else
  {
    dbsp ("not enough memory\n");
  }
  dbsp ("SEND_SMS NOT_OK\n");
  return 0;
}

u8 cmp_msg (u8 * sms, u8 * msg)
{
  u8 len_sms;
  u8 len_msg;
  u8 i;

  if (msg == NULL)
    return 0;
  if (sms == NULL)
    return 0;

  len_sms = strlen (sms);
  len_msg = strlen (msg);
  if (len_sms != len_msg)
    return 0;

  for (i = 0; i < len_sms; i++)
    if (toupper (sms[i]) != toupper (rb (msg + i)))
      return 0;

  return 1;
}

void rec_sms (File_apdu_data * fd)
{
  u8 *t;
  u8 *data = fd->data;
  u8 i;
  u16 j;
  u8 *s;
  u8 l;
  u8 *ms;
  u8 *msg;
  SEdge *nrs = rw (&pers_mem->numbers);
  SNode *n;
  Number_cap *nc;

#ifdef DEBUG
  dbsp ("REC_SMS\n");
  for (i = 0; i < fd->p3; i++)
  {
    dbch (data[i]);
    dbc (' ');
  }
  dbc ('\n');
#endif

  if ((data[0] & 0x07) == 3)	//received, to be read
  {
    s = data;
    s++;			// status
    i = *s;
    s += i + 1;			// TS-Service-Centre-Address

    i = *s;
    if ((i & 0x03) == 0x00)	//deliver
    {
      msg = malloc (161);
      if (msg)
      {
	if (i & 0x40)
	{
// UHDI
	  u16 bits, b1;

	  dbsp ("UHDI\n");
	  t = tpdu_seek (s, T_SMS_DCS);
	  j = *t;
	  t = tpdu_seek (s, T_SMS_UDL);
	  l = *t;
	  t++;
	  i = *t;		//UDHL
	  if (dcs_is_7b (j))
	  {
	    dbsp ("7B\n");
	    j = 7 - ((1 + i) * 8) % 7;	//padding, fill bits
	    if (j == 7)
	      j = 0;
	    dbsp ("JP ");
	    dbih (j);
	    dbc ('\n');
	    for (b1 = 0; b1 < bits; b1++)
	      set_bit (msg, b1, get_bit (t, b1 + j));

	    i = bits / 7;
	    dcs_78 (msg, i, DCS_7_TO_8);
	    msg[i] = '\0';
	  }
	  else
	  {
	    dbsp ("8B\n");
	    memcpy (msg, t + 1 + i, l - 1 - i);
	    msg[l - 1 - i] = '\0';
	  }
	}
	else
	{
	  t = tpdu_seek (s, T_SMS_UDL);
	  i = *t;
	  memcpy (msg, t + 1, 140);

	  t = tpdu_seek (s, T_SMS_DCS);
	  if (dcs_is_7b (*t))
	    dcs_78 (msg, i, DCS_7_TO_8);
	  msg[i] = '\0';
	}

#ifdef DEBUG
	dbsp ("MSG: ");
	l = strlen (msg);
	dbch (l);
	dbc (' ');
	for (i = 0; i < l; i++)
	  dbc (msg[i]);
	dbc ('\n');
#endif

	t = tpdu_seek (s, T_SMS_AA);
	ms = msisdncpy (t, MSISDN_SMS, MEM_R);

	refsms_d (fd);

#ifdef CONFIG_AIRCON
	if (cmp_msg (msg, t_keyword_ac_on))
	{
	  dbsp ("KW_AC_ON\n");

	  while (nrs != NULL)
	  {
	    n = rw (&nrs->t);
	    nc = rw (&n->p);

	    if (msisdncmp (rw (&nc->nr), MSISDN_ADN, ms, MSISDN_SMS)
		&& rb (&nc->aircon))
	    {
	      dbsp ("NUMBER OK\n");
	      set_ac_on ();
	      send_status (ms, MSISDN_SMS, rb (&nc->turbo_sms));
	      free (ms);
	      free (msg);
	      return;
	    }
	    nrs = rw (&nrs->next);
	  }
	  free (ms);
	  free (msg);
	  dbsp ("NO NUMBER or AC allowed\n");
	  return;
	}

	if (cmp_msg (msg, t_keyword_ac_off))
	{
	  dbsp ("KW_AC_OFF\n");

	  while (nrs != NULL)
	  {
	    n = rw (&nrs->t);
	    nc = rw (&n->p);

	    if (msisdncmp (rw (&nc->nr), MSISDN_ADN, ms, MSISDN_SMS)
		&& rb (&nc->aircon))
	    {
	      dbsp ("NUMBER OK\n");
	      set_ac_off ();
	      send_status (ms, MSISDN_SMS, rb (&nc->turbo_sms));
	      free (ms);
	      free (msg);
	      return;
	    }
	    nrs = rw (&nrs->next);
	  }
	  free (ms);
	  free (msg);
	  dbsp ("NO NUMBER or AC allowed\n");
	  return;
	}
#endif

#ifdef CONFIG_BLOCK
	if (cmp_msg (msg, t_keyword_block_on))
	{
	  dbsp ("KW_BLOCK_ON\n");

	  while (nrs != NULL)
	  {
	    n = rw (&nrs->t);
	    nc = rw (&n->p);

	    if (msisdncmp (rw (&nc->nr), MSISDN_ADN, ms, MSISDN_SMS)
		&& rb (&nc->block))
	    {
	      dbsp ("NUMBER OK\n");
	      set_block_on ();
	      send_status (ms, MSISDN_SMS, rb (&nc->turbo_sms));
	      free (ms);
	      free (msg);
	      return;
	    }
	    nrs = rw (&nrs->next);
	  }
	  free (ms);
	  free (msg);
	  dbsp ("NO NUMBER or BLOCK allowed\n");
	  return;
	}

	if (cmp_msg (msg, t_keyword_block_off))
	{
	  dbsp ("KW_BLOCK_OFF\n");

	  while (nrs != NULL)
	  {
	    n = rw (&nrs->t);
	    nc = rw (&n->p);

	    if (msisdncmp (rw (&nc->nr), MSISDN_ADN, ms, MSISDN_SMS)
		&& rb (&nc->block))
	    {
	      dbsp ("NUMBER OK\n");
	      set_block_off ();
	      send_status (ms, MSISDN_SMS, rb (&nc->turbo_sms));
	      free (ms);
	      free (msg);
	      return;
	    }
	    nrs = rw (&nrs->next);
	  }
	  free (ms);
	  free (msg);
	  dbsp ("NO NUMBER or BLOCK allowed\n");
	  return;
	}
#endif

	if (cmp_msg (msg, t_keyword_alarm_off))
	{
	  dbsp ("KW_ALARM_OFF\n");

	  while (is_alarm && nrs != NULL)
	  {
	    n = rw (&nrs->t);
	    nc = rw (&n->p);

	    if (msisdncmp (rw (&nc->nr), MSISDN_ADN, ms, MSISDN_SMS)
		&& rb (&nc->sms))
	    {
	      dbsp ("NUMBER OK\n");
	      was_manual_on_delay = 1;
	      was_manual_off_delay = 0;
	      is_alarm = 0;
	      is_alarm_1 = 0;
	      is_alarm_2 = 0;
	      is_alarm_accel = 0;
	      is_val_valid = 0;
	      alarm_reported = 0;
	      set_alarm_off ();

	      send_status (ms, MSISDN_SMS, rb (&nc->turbo_sms));
	      free (ms);
	      free (msg);
	      return;
	    }
	    nrs = rw (&nrs->next);
	  }
	  free (ms);
	  free (msg);
	  dbsp ("NO NUMBER nor ALARM\n");
	  return;
	}

	if (cmp_msg (msg, t_keyword_on))
	{
	  dbsp ("KW_ON\n");

	  while (nrs != NULL)
	  {
	    n = rw (&nrs->t);
	    nc = rw (&n->p);

	    if (msisdncmp (rw (&nc->nr), MSISDN_ADN, ms, MSISDN_SMS)
		&& rb (&nc->sms))
	    {
	      dbsp ("NUMBER OK\n");
	      if (is_locked == 0)
	      {
		reset_vals ();
		is_locked = 1;
		if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER_EVO)
		{
		  accel_flush ();
		  uart2i2c_write_interval (accel_interval);
		}
		setmenu (NULL);
	      }
	      send_status (ms, MSISDN_SMS, rb (&nc->turbo_sms));
	      free (ms);
	      free (msg);
	      return;
	    }
	    nrs = rw (&nrs->next);
	  }
	  free (ms);
	  free (msg);
	  dbsp ("NO NUMBER\n");
	  return;
	}

	if (cmp_msg (msg, t_keyword_off))
	{
	  dbsp ("KW_OFF\n");

	  while (nrs != NULL)
	  {
	    n = rw (&nrs->t);
	    nc = rw (&n->p);

	    if (msisdncmp (rw (&nc->nr), MSISDN_ADN, ms, MSISDN_SMS)
		&& rb (&nc->sms))
	    {
	      dbsp ("NUMBER OK\n");
	      if (is_locked == 1)
	      {
		reset_vals ();
		setmenu (NULL);
	      }
	      send_status (ms, MSISDN_SMS, rb (&nc->turbo_sms));
	      free (ms);
	      free (msg);
	      return;
	    }
	    nrs = rw (&nrs->next);
	  }
	  free (ms);
	  free (msg);
	  dbsp ("NO NUMBER\n");
	  return;
	}

	dbsp ("KW_STATUS\n");

	while (nrs != NULL)
	{
	  n = rw (&nrs->t);
	  nc = rw (&n->p);

	  if (msisdncmp (rw (&nc->nr), MSISDN_ADN, ms, MSISDN_SMS)
	      && rb (&nc->status))
	  {
	    dbsp ("NUMBER OK\n");
	    send_status (ms, MSISDN_SMS, rb (&nc->turbo_sms));
	    free (ms);
	    free (msg);
	    return;
	  }
	  nrs = rw (&nrs->next);
	}

	free (ms);
	free (msg);
	dbsp ("NO NUMBER or STATUS allowed\n");
	return;
      }
    }
    refsms_d (fd);
    return;
  }

  store_sms_2_sim ();		// not incoming message, something user
}

void check_net (void *data)
{
//  if (poll_int == 0xff)
//    my_poll_interval (rb (&pers_mem->poll_interval));
  // nr of CID -> net reset
  if (has_locinfo)
  {
    u8 *s;
    u8 i, j;

    s = provide_local_info ();
    j = get_tag (s, T_LOCATION_INFO);
    if (j != 0)
    {
      last_time_net = cur_time;
#ifdef DEBUG
      j += 2;
      dbsp ("LOCINFO: ");
      for (i = 0; i < 7; i++)
      {
	dbch (s[j + i]);
	dbc (' ');
      }
      dbc ('\n');
#endif
    }
    else
    {
      u16 no = cur_time - last_time_net;

      no = no / 60;
      dbsp ("NO LOCINFO ");
      dbih (no);
      dbc ('\n');
      if (no > rw (&pers_mem->net_reset))
      {
	dbsp ("NO_NET_REFRESH\n");
	last_time_net = cur_time;
	dbsp (">Q_REFRESH_SIM_INIT\n");
	refresh (Q_REFRESH_SIM_INIT, 0, 0, 0);
	dbsp ("<Q_REFRESH_SIM_INIT\n");
	//refresh(Q_REFRESH_SIM_RESET, 0,0,0); - NO c55 chce PIN
	//refresh(Q_REFRESH_SIM_INIT_FULL_FILE, 0,0,0);
      }
    }
  }
}

void mt_call (u8 * data)
{
  u8 j, i;
  u8 l;

#define MAX_MSISDN	20
  u8 ms[MAX_MSISDN];
  SEdge *nrs = rw (&pers_mem->numbers);
  SNode *n;
  u8 *ms_adn;
  Number_cap *nc;
  u8 *ms_adn_x;
  u8 lx, ly;

  dbsp ("MT_CALL ");
  dbch (is_locked);
  dbc ('\n');
  j = get_tag (data, T_ADDRESS);
  if (j != 0)
  {
    dbsp ("ADDRESS: ");
    j++;			//tag
    l = data[j] - 2;

#ifdef DEBUG
    for (i = 0; i < data[j]; i++)
    {
      dbch (data[j + i + 1]);
      dbc (' ');
    }
    dbc ('\n');
#endif

    j++;			//len
    j++;			//ADDRESS_LEN
    j++;			//TON/NPI
    i = 0;

    while (l && i < MAX_MSISDN - 1)
    {
      if ((data[j] & 0x0F) >= 0 && (data[j] & 0x0F) <= 9)
	ms[i++] = (data[j] & 0x0F) + '0';
      if (((data[j] & 0xF0) >> 4) >= 0 && ((data[j] & 0xF0) >> 4) <= 9)
	ms[i++] = ((data[j] & 0xF0) >> 4) + '0';
      j++;
      l--;
    }

    ms[i] = '\0';
    l = strlen (ms);

#ifdef DEBUG
    i = 0;
    dbsp ("STR: ");
    while (ms[i] != '\0')
      dbc (ms[i++]);
    dbc ('\n');
#endif

// check agains numbers
    while (nrs != NULL)
    {
      n = rw (&nrs->t);
      nc = rw (&n->p);
      ms_adn_x = msisdn2str (rw (&nc->nr), MSISDN_ADN, MEM_R);	// TODO no mem
      ly = lx = strlen (ms_adn_x);
      if (lx > l)
	ly = l;
      for (i = 0; i < ly; i++)
	if (ms_adn_x[lx - i - 1] != ms[l - i - 1])
	  goto X2;
      if (lx > l && lx - l > 4)
	goto X2;
      if (lx < l && l - lx > 4)
	goto X2;
      goto X1;

    X2:
      free (ms_adn_x);
      nrs = rw (&nrs->next);
    }
    dbsp ("NO NUMBER or AC allowed\n");
    return;
  }
  else
  {
    dbsp ("NO ADDRESS\n");
    return;
  }

X1:
  free (ms_adn_x);
  if (rb (&nc->call) == 0)
    return;

  if (is_locked == 0)
  {
    reset_vals ();
    is_locked = 1;
    if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER_EVO)
    {
      accel_flush ();
      uart2i2c_write_interval (accel_interval);
    }
    is_val_valid = 1;
    accels_measure (&vx, &vy);

#ifdef CONFIG_OLD
    nr_count = 0;
    x_max = 0;
    y_max = 0;
    nr_alarm = 0;
    x_burst_min = 0xFFFF;
    y_burst_min = 0xFFFF;
    x_burst_max = 0;
    y_burst_max = 0;
#endif
  }
  else
  {
    reset_vals ();
    set_block_off ();
  }

  dbsp ("MT_CALL_1 ");
  dbch (is_locked);
  dbc ('\n');

//#define CONFIRM_ALL
#ifdef CONFIRM_ALL
  if (rb (&nc->call_confirm))	// and number has call confirmation
#else
  if (is_locked == 1 && rb (&nc->call_confirm))	// and number has call confirmation
#endif
  {
    ms_adn = msisdncpy (rw (&nc->nr), MSISDN_ADN, MEM_R);
    if (ms_adn == NULL)
      return;
    send_status (ms_adn, MSISDN_ADN, rb (&nc->turbo_sms));
    free (ms_adn);
  }

  setmenu (NULL);
}

void report_alarm (void *data)
{
  SEdge *nrs = rw (&pers_mem->numbers);
  SNode *n;
  Number_cap *nc;
  u8 *ms;
  u8 *fax_sms;

  dbsp (">report_alarm\n");
  alarm_being_reported = 1;
#ifdef CONFIG_OPTO_OUT_1_PULSE
  {
#define PULSE_LOOPS	30
    u8 i;

    opto_out_1_on ();
    for (i = 0; i < PULSE_LOOPS; i++)
      more_time ();
    opto_out_1_off ();
  }
#endif
  while (nrs)
  {
    n = rw (&nrs->t);
    nc = rw (&n->p);
    if (rb (&nc->alarm))
    {
      fax_sms = rw (&nc->fax_sms);
      ms = msisdncpy (rw (&nc->nr), MSISDN_ADN, MEM_R);
      if (ms == NULL)
	return;
      if (fax_sms)
      {
// send only FAX SMS
	u8 *tmp;
	u8 i;

	i = strlen (fax_sms) + 1;
	tmp = malloc (i);
	if (tmp)
	{
	  memcpy (tmp, fax_sms, i);

	  i = dcs_78 (tmp, i - 1, DCS_8_TO_7);
/*r = */ send_sms (tmp, i, ms, MSISDN_ADN, 0, 0, NULL, NULL);
// TODO if not sent!
	  free (tmp);
	  alarm_reported = 1;
	}
      }
      else
      {
	if (send_status (ms, MSISDN_ADN, rb (&nc->turbo_sms)))
	{
	  if (is_alarm)
	  {
	    alarm_time_reported = cur_time;
	    alarm_reported = 1;
	  }
	  else if (get_panic () == INPUT_ACTIVE_LEVEL)
	    alarm_panic_reported = 1;
	}
      }
      free (ms);
    }

#if 0
    if (rb (&nc->alarm_call))
    {
      ms = msisdncpy (rw (&nc->nr), MSISDN_ADN, MEM_R);
      if (ms == NULL)
	return;
      dbsp (">report_alarm_call\n");
      set_up_call (ms, MSISDN_ADN, NULL);
      dbsp ("<report_alarm_call\n");
      alarm_reported = 1;
      free (ms);
    }
#endif
    nrs = rw (&nrs->next);
  }
  alarm_being_reported = 0;
  dbsp ("<report_alarm\n");
}

void check_time ()
{
  if (cur_time > 60000)
  {
// overflow
    cur_time = 0;
    manual_lock_time = cur_time - manual_lock_time;
    last_time_net = cur_time - last_time_net;
    alarm_time = cur_time - alarm_time;
    check_net_time = cur_time - check_net_time;
  }
  cur_time += poll_int;
}

u8 check_manual_on_ok ()
{
  u16 d;

  dbsp (">check_manual_on_ok\n");
  if (was_manual_lock == 0)
    return 1;
  if (was_manual_on_delay)
    return 1;
  d = (cur_time - manual_lock_time) / 60;
  dbsp ("manual_lock_time ");
  dbih (manual_lock_time);
  dbc (' ');
  dbih (d);
  dbc ('\n');
  if (d >= rb (&pers_mem->manual_delay_on))
  {
    was_manual_on_delay = 1;
    return 1;
  }
  return 0;
}

u8 check_manual_off_ok ()
{
  u16 d;

  dbsp (">check_manual_off_ok\n");
  if (was_manual_lock == 0)
    return 1;
  if (was_manual_off_delay)
    return 1;
  d = (cur_time - alarm_time) / 60;
  dbsp ("alarm_time ");
  dbih (alarm_time);
  dbc (' ');
  dbih (d);
  dbc ('\n');
  if (d >= rb (&pers_mem->manual_delay_off))
  {
    was_manual_off_delay = 1;
    return 1;
  }
  return 0;
}

u8 repeated_alarm ()
{
  u8 val = rb (&pers_mem->repeated_sms_delay);
  u16 d;

  if (val != 0)
  {
    d = (cur_time - alarm_time_reported) / 60;
    if (d >= val)
    {
      dbsp ("repeated_alarm_time ");
      dbih (alarm_time_reported);
      dbc (' ');
      dbih (d);
      dbc ('\n');

      return 1;
    }
  }
  return 0;
}

u8 check_net_time_elapsed ()
{
  dbsp (">check_net_time_elapsed ");
  dbih (check_net_time);
  dbc ('\n');

  if (check_net_time > DEF_NET_CHECK * 60)
  {
    dbsp ("check_net_time_elapsed\n");
    check_net_time = 0;
    return 1;
  }
  else
    return 0;
}

void action_menu (Menu_selection_data * x)
{
  u8 item = x->item;
  SCtx *c;

  if (item == 0)		// lock/unlock
  {
    if (is_locked)
      manual_unlock ();
    else
      manual_lock ();

    setmenu (NULL);
  }
  else
  {
    if (rb (&pers_mem->is_pin))
    {
      u8 *res;
      u8 j, i;

      res =
	get_input (locale (lc_Enter_PIN), 4, 4, NULL,
		   Q_GET_INPUT_DIGITS | Q_GET_INPUT_NO_ECHO);
      if (res == ENULL || res == NULL)
	return;

      for (i = 0; i < 4; i++)
	if (res[2 + i] != rb (&pers_mem->pin[i]))
	{
	  display_text (locale (lc_Wrong_PIN), NULL);
	  return;
	}
    }
    c = spider_init ();
    spider_set_order (c, ORDER_R, ORDER_P, ORDER_E, ORDER_D);
    c->eP = &alarm_edges_p;

    if (proc_8 (PROC_8_LANGUAGE) == LC_RUSSIAN)
      c->style |= SPIDER_STYLE_UCS2;

    if (item == 1)		// numbers
      c->n = &alarm_n_numbers;
    else			// config
      c->n = &alarm_n_config;
    spider (c);
  }
}

void turbo_handler (u8 action, void *data)
{
  switch (action)
  {
    case ACTION_APP_REGISTER:
      {
	Pers_mem *p = emalloc (sizeof (Pers_mem));

	if (p)
	{
	  u8 i;

	  for (i = 0; i < 4; i++)
	    wb (&p->pin[i], '1' + i);

	  ww (&p->numbers, NULL);
	  wb (&p->sens, DEF_SENS);
	  wb (&p->baudrate, DEF_BAUDRATE);
	  wb (&p->manual_delay_on, DEF_MANUAL_DELAY_ON);
	  wb (&p->manual_delay_off, DEF_MANUAL_DELAY_OFF);
	  wb (&p->repeated_sms_delay, 0);
	  ww (&p->net_reset, DEF_NET_RESET);
	  wb (&p->alarm_1, 0);
	  wb (&p->alarm_2, 0);
	  wb (&p->central_lock, 0);
	  wb (&p->is_pin, 0);
	  wb (&p->poll_interval, DEF_POLL_INTERVAL);
	  wb (&p->poll_interval_new, ACCEL_INTERVAL);
	  wb (&p->interval_nmea, 1);	//TODO
//        uart2i2c_write_txfifo_data ("@OI 1\n\r", 7); //TODO
	  wb (&p->status_spawn_bug, 0);

	  reg_app_data (p);
	}

	set_proc_8 (PROC_8_CONFIG_SETUP, 0);
	set_proc_8 (PROC_8_CONFIG_BINARY_CHOICE, 0);
	set_proc_8 (PROC_8_CONFIG_SIM_FIRST, 0);
      }
      break;
    case ACTION_APP_UNREGISTER:
      {
	Pers_mem *p = app_data ();
	SEdge *e, *f;
	SNode *n;
	u8 *t;
	Number_cap *nc;

	e = rw (&p->numbers);
	while (e)
	{
	  n = rw (&e->t);
	  t = rw (&n->text);
	  efree (t);
	  nc = rw (&n->p);
	  efree (rw (&nc->fax_sms));
	  t = rw (&nc->nr);
	  efree (t);
	  efree (nc);
	  efree (n);
	  f = rw (&e->next);
	  efree (e);
	  e = f;
	}

	efree (p);
	free (gpsData);
      }
      break;
    case ACTION_FIRST_STK:
      stk_thread (setpoll, NULL);
      break;
    case ACTION_EVENT_MT_CALL:
      stk_thread (mt_call, data);
      break;
    case ACTION_SMS:
      stk_thread (rec_sms, data);
      break;
    case ACTION_APP_INIT:
      dbsp ("INIT\n");
      nr_status = 0;
      poll_int = 30;
      gpsData = malloc (sizeof (gpsDataStruct));
      pers_mem = app_data ();
      if (rb (&pers_mem->sens) == 1)
      {
//LOW
	alarm_x = alarm_y = DEF_SENS_D_LOW;
      }
      else if (rb (&pers_mem->sens) == 2)
      {
//MEDIUM
	alarm_x = alarm_y = DEF_SENS_D_MEDIUM;
      }
      else
      {
//HIGH
	alarm_x = alarm_y = DEF_SENS_D_HIGH;
      }

      reset_vals ();
      has_locinfo = 0;
      last_time_net = 0;
      cur_time = 0;
      check_net_time = 0;

      is_locked = 0;		//
      is_aircon = 0;		//all outputs are not active at the begining
      is_blocked = 0;

      alarm_panic_reported = 0;

      reg_action (ACTION_STATUS);
      reg_action (ACTION_EVENT_MT_CALL);
      reg_action (ACTION_SMS);

      if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER)
      {
	init_accel ();
	init_adc ();
      }
      else if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER_EVO)
      {
	init_variables ();
	init_mcuPorts ();
	init_I2c ();
	enableParserGps ();
//      clearGpsDataGps ();
	if (rb (&pers_mem->baudrate) == 1)
	{			//4800
	  uart2i2c_write_ubrr (103);
	}
	else if (rb (&pers_mem->baudrate) == 2)
	{			//9600
	  uart2i2c_write_ubrr (51);
	}
	else if (rb (&pers_mem->baudrate) == 3)
	{			//19200
	  uart2i2c_write_ubrr (25);
	}
	else
	{			//38400
	  uart2i2c_write_ubrr (12);
	}
	accel_interval = rb (&pers_mem->poll_interval_new);
//      uart2i2c_write_interval (accel_interval);
      }
      init_alarm_pins ();
      preset_alarm_outputs ();

#ifdef CONFIG_OLD
      nr_count = 0;
      x_max = 0;
      y_max = 0;
      nr_alarm = 0;
      x_burst_min = 0xFFFF;
      y_burst_min = 0xFFFF;
      x_burst_max = 0;
      y_burst_max = 0;
#endif

#ifdef CONFIG_AC_ON
      set_ac_on ();
#endif

      break;

    case ACTION_INSERT_MENU:
      {
	u8 *t = terminal_profile ();

	if (t[0] >= 5 && t[5] & 0x02)
	  has_mt_call = 1;
	else
	  has_mt_call = 0;
	if (t[0] >= 8 && t[8] & 0x10)
	  has_idle_text = 1;
	else
	  has_idle_text = 0;
	if (t[0] >= 4 && t[4] & 0x40)
	  has_locinfo = 1;
	else
	  has_locinfo = 0;
      }

      set_menu_alpha (locale (lc_Auto_Alarm));
      set_menu ();
      break;

    case ACTION_MENU_SELECTION:
      stk_thread (action_menu, data);
      break;

    case ACTION_STATUS:
      dbsp (">STATUS\n");
      if (rb (&pers_mem->status_spawn_bug) && nr_status)
      {
	nr_status = 0;
	break;
      }
      nr_status = 1;
// time
      check_time ();
      dbsp ("STATUS_1 ");
      dbih (cur_time);
      dbc ('\n');

#define DEF_CHARGER_OFF_START	10800
#define DEF_CHARGER_OFF_STOP	10900

      if (cur_time >= DEF_CHARGER_OFF_START
	  && cur_time <= DEF_CHARGER_OFF_STOP)
      {
// off - active 1
//__dbc('H');__dbc('\n');
	sbi (ALARM_OUT_CHARGER_PORT, ALARM_OUT_CHARGER_PORT_PIN);
      }
      else
      {
// on - active 0
//__dbc('L');__dbc('\n');
	cbi (ALARM_OUT_CHARGER_PORT, ALARM_OUT_CHARGER_PORT_PIN);
      }

// check net
      if (check_net_time_elapsed ())
	stk_thread (check_net, NULL);

      dbsp ("STATUS_2\n");

// update gps
      actualizePositionGps ();

// panic button
      {
	u8 val = get_panic ();

	if (val == INPUT_ACTIVE_LEVEL)
	{
	  set_alarm_on ();	//should be?

	  dbsp ("STATUS_PANIC\n");
	  if (alarm_panic_reported == 0 && alarm_being_reported == 0)
	  {
	    stk_thread (report_alarm, NULL);
	  }

	  if (alarm_reported_btn == 0 && alarm_being_reported == 0)	// after SMS were sent, don't colide with sms being sent
	  {
	    //              alarm_reported_btn = 1;
	    set_alarm_btn ();
	  }
	}
	else
	{
	  alarm_panic_reported = 0;
	}
      }

// check central_lock
      if (rb (&pers_mem->central_lock))
      {
	u8 val = get_central_lock ();

	if (val == INPUT_ACTIVE_LEVEL)
	{
	  if (is_locked == 0)
	  {
	    // LOCK
	    reset_vals ();
	    is_locked = 1;
	    is_val_valid = 1;

	    if (version_hwd () == TURBO_SIM_TOOLKIT_ADAPTER_EVO)
	    {
	      accel_flush ();
	      uart2i2c_write_interval (accel_interval);
	    }

	    accels_measure (&vx, &vy);

	    stk_thread (setmenu, NULL);
	  }
	}
	else
	{
	  if (is_locked == 1)
	  {
	    u16 msecs;

	    //UNLOCK
	    reset_vals ();
	    set_block_off ();
	    stk_thread (setmenu, NULL);
	    set_cancel_alarm2_on ();
	    for (msecs = 0; msecs < CONFIG_CANCEL_ALARM2_DELAY_MILISEC;
		 msecs++)
	      delay_1ms ();
	    set_cancel_alarm2_off ();
	  }
	}
      }

      dbsp ("STATUS_3\n");
      if (is_locked)
      {
	u8 is_moving = 0;

	dbsp ("STATUS_3_1\n");
	if (check_manual_on_ok ())
	{
	  dbsp ("STATUS_3_2\n");
	  // alarm_1
	  if (rb (&pers_mem->alarm_1))
	  {
	    u8 val = get_alarm_1 ();

	    if (val == INPUT_ACTIVE_LEVEL)
	    {
	      if (is_alarm == 0)
		alarm_time = cur_time;
	      is_alarm = 1;
	      is_alarm_1 = 1;
	    }
	  }

	  // alarm_2
	  if (rb (&pers_mem->alarm_2))
	  {
	    u8 val = get_alarm_2 ();

	    if (val == INPUT_ACTIVE_LEVEL)
	    {
	      if (is_alarm == 0)
		alarm_time = cur_time;
	      is_alarm = 1;
	      is_alarm_2 = 1;
	    }
	  }

	  // alarm_akcel
	  {
	    b16 x, y;

	    accels_measure (&x, &y);

	    dbsp ("STATUS_3_3 ");
	    dbih (x);
	    dbc (' ');
	    dbih (y);
	    dbc ('\n');
	    if (is_val_valid == 0)
	    {
	      vx = x;
	      vy = y;
	      is_val_valid = 1;
#ifdef CONFIG_MEASURE
	      max_dx = 0;
	      max_dy = 0;
#endif
	    }
	    else
	    {
	      dx = abs (vx - x);
	      dy = abs (vy - y);

#ifdef CONFIG_MEASURE
	      if (dx > max_dx)
		max_dx = dx;
	      if (dy > max_dy)
		max_dy = dy;
#endif
	      dbsp ("STATUS_3_4 ");
	      dbih (dx);
	      dbc (' ');
	      dbih (dy);
	      dbc ('\n');

	      if (is_alarm_accel == 0)
	      {
		if (dx >= alarm_x || dy >= alarm_y)
		{
		  if (is_alarm == 0)
		    alarm_time = cur_time;
		  is_alarm_accel = 1;
		  is_alarm = 1;
		}
		else
		{
		  vx = x;
		  vy = y;
		}
	      }
	      else
	      {
		// "ocko"
		if (dx >= alarm_x || dy >= alarm_y)
		{
		  dbsp ("IS MOVING\n");
		  is_moving = 1;
		  vx = x;
		  vy = y;
		}
	      }
	    }
	  }
	}

	if (is_alarm)
	{
	  dbsp ("STATUS_3_5\n");
	  if (check_manual_off_ok ())
	  {
	    set_alarm_on ();
	    dbsp ("STATUS_3_6\n");
	    if (alarm_reported == 0 || (repeated_alarm () && is_moving))
	      if (alarm_being_reported == 0)
	      {
		stk_thread (report_alarm, NULL);
	      }

	    if (alarm_reported_btn == 0 && alarm_being_reported == 0)	// after SMS were sent, don't colide with sms being sent
	    {
	      alarm_reported_btn = 1;
	      set_alarm_btn ();
	    }

	  }
	}
      }

      dbsp ("STATUS_4\n");
      if (is_blocked)
      {
	// nejdriv brzdy, dalsi status pak blokace
	if (is_brake_lights == 1)
	  set_block_on ();
	else
	  set_brake_lights_on ();
      }
      dbsp ("<STATUS\n");
    default:
      break;
  }
}
